GNU bug report logs - #21816
elisp-mode-tests fails on a case-preserving filesystem

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Juanma Barranquero <lekktu@HIDDEN>; dated Mon, 2 Nov 2015 16:44:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 5 Nov 2015 12:27:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 05 07:27:02 2015
Received: from localhost ([127.0.0.1]:54227 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZuJd7-0000Xn-8e
	for submit <at> debbugs.gnu.org; Thu, 05 Nov 2015 07:27:01 -0500
Received: from mail-lb0-f177.google.com ([209.85.217.177]:33897)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZuJcm-0000XH-Vf
 for 21816 <at> debbugs.gnu.org; Thu, 05 Nov 2015 07:26:59 -0500
Received: by lbbwb3 with SMTP id wb3so34087445lbb.1
 for <21816 <at> debbugs.gnu.org>; Thu, 05 Nov 2015 04:26:40 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=2a+/aylFMmU/sdRd8TX5YCixbCkDeHYWYJ9gNzEStDA=;
 b=S/V/nXcTbN/vCDP7MX/hiq6e75V/pEyj1gBmut90ouoip/hdaavveTPT+CyPeO/1BM
 U37lPw6urEJipze+CAWVRx1HyudcOvkpTHcyTMgTGTSPwmSTbnGKjBtp7OLbxseFrQLS
 o1+w0iqsvTKobDloqVi2u9WSQE+k06c6mlcQMliCjza3XJqLuuPN1PndLiKO7zl7PHw0
 o7cPWzwXEHWG6QmUyYoI5C+uxdVAcLWgLh9XgR/Gk3cyh3VuxECCs67jERagnBI2aAu1
 d4dZtjTGW1odaqXLt6KNJMIvEElH4oM7WCxbFa8K3Ct3iBXpNxw+tC5/gy6wzOqryStN
 taug==
X-Received: by 10.112.234.163 with SMTP id uf3mr3739677lbc.15.1446726400177;
 Thu, 05 Nov 2015 04:26:40 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Thu, 5 Nov 2015 04:26:00 -0800 (PST)
In-Reply-To: <86pozpye8p.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86pozpye8p.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Thu, 5 Nov 2015 13:26:00 +0100
Message-ID: <CAAeL0ST+kLU1k9Gk_H5dH-WgjS1_-9BKCFvdHhBviUtcsYAABQ@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c317e82b7b420523ca3df4
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c317e82b7b420523ca3df4
Content-Type: text/plain; charset=UTF-8

On Wed, Nov 4, 2015 at 4:29 PM, Stephen Leake <
stephen_leake@HIDDEN> wrote:

> If the policy is that `load-path' may contain directory names that are
> different from the disk name, then taking advantage of that should not
> produce warnings.
>
> But that discussion should move to a separate bug/subject.

For this specific test file, I could fix the problem with this patch, if
you and Dmitry are OK with it.

diff --git i/test/automated/elisp-mode-tests.el
w/test/automated/elisp-mode-tests.el
index 1085b54..38c0b3b 100644
--- i/test/automated/elisp-mode-tests.el
+++ w/test/automated/elisp-mode-tests.el
@@ -209,6 +209,7 @@ xref-elisp-deftest
            (debug (symbolp "name")))
   `(ert-deftest ,(intern (concat "xref-elisp-test-" (symbol-name name))) ()
-     (xref-elisp-test-run ,computed-xrefs ,expected-xrefs)
-     ))
+     (let ((find-file-suppress-same-file-warnings t))
+       (xref-elisp-test-run ,computed-xrefs ,expected-xrefs)
+       )))

 ;; When tests are run from the Makefile, 'default-directory' is $HOME,

--001a11c317e82b7b420523ca3df4
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Wed, Nov 4, 2015 at 4:29 PM, Stephen Leake &lt;<a href=
=3D"mailto:stephen_leake@HIDDEN" target=3D"_blank">stephen_leake@=
stephe-leake.org</a>&gt; wrote:<br><br><div>&gt; If the policy is that `loa=
d-path&#39; may contain directory names that are<br>&gt; different from the=
 disk name, then taking advantage of that should not<br>&gt; produce warnin=
gs.<br>&gt;<br>&gt; But that discussion should move to a separate bug/subje=
ct.<br><br></div><div>For this specific test file, I could fix the problem =
with this patch, if you and Dmitry are OK with it.</div><div><br></div><div=
><div>diff --git i/test/automated/elisp-mode-tests.el w/test/automated/elis=
p-mode-tests.el</div><div>index 1085b54..38c0b3b 100644</div><div>--- i/tes=
t/automated/elisp-mode-tests.el</div><div>+++ w/test/automated/elisp-mode-t=
ests.el</div><div>@@ -209,6 +209,7 @@ xref-elisp-deftest</div><div>=C2=A0 =
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (debug (symbolp &quot;name&quot;)))</div=
><div>=C2=A0 =C2=A0`(ert-deftest ,(intern (concat &quot;xref-elisp-test-&qu=
ot; (symbol-name name))) ()</div><div>- =C2=A0 =C2=A0 (xref-elisp-test-run =
,computed-xrefs ,expected-xrefs)</div><div>- =C2=A0 =C2=A0 ))</div><div>+ =
=C2=A0 =C2=A0 (let ((find-file-suppress-same-file-warnings t))</div><div>+ =
=C2=A0 =C2=A0 =C2=A0 (xref-elisp-test-run ,computed-xrefs ,expected-xrefs)<=
/div><div>+ =C2=A0 =C2=A0 =C2=A0 )))</div><div>=C2=A0</div><div>=C2=A0;; Wh=
en tests are run from the Makefile, &#39;default-directory&#39; is $HOME,</=
div></div><div><br></div><div><br></div><div><br></div></div>

--001a11c317e82b7b420523ca3df4--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 19:39:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 14:39:33 2015
Received: from localhost ([127.0.0.1]:53689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu3u8-0004kY-Tc
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 14:39:33 -0500
Received: from gproxy4-pub.mail.unifiedlayer.com ([69.89.23.142]:53889)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Zu3u5-0004kN-5q
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 14:39:30 -0500
Received: (qmail 20534 invoked by uid 0); 4 Nov 2015 19:39:24 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy4.mail.unifiedlayer.com with SMTP; 4 Nov 2015 19:39:24 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id dXfJ1r00m2UdiVW01XfMJL; Wed, 04 Nov 2015 12:39:24 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=HMPm_nkzBoqVwBawQJwA:9
Received: from [76.218.37.33] (port=58971 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Zu3WB-0005DF-Kh; Wed, 04 Nov 2015 12:14:47 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <83h9l2vloe.fsf@HIDDEN> <864mh2219i.fsf@HIDDEN>
 <83d1vqv3af.fsf@HIDDEN> <86y4eexew5.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 13:14:31 -0600
In-Reply-To: <86y4eexew5.fsf@HIDDEN> (Stephen Leake's message of
 "Wed, 04 Nov 2015 04:00:58 -0600")
Message-ID: <86h9l1y3u0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

I've now looked at the definition of `file-equal-p':

  (let ((handler (or (find-file-name-handler file1 'file-equal-p)
                     (find-file-name-handler file2 'file-equal-p))))
    (if handler
        (funcall handler 'file-equal-p file1 file2)
      (let (f1-attr f2-attr)
        (and (setq f1-attr (file-attributes (file-truename file1)))
	     (setq f2-attr (file-attributes (file-truename file2)))
	     (equal f1-attr f2-attr))))))

This implies there are two reasons why `file-truename' (and by extension
`file-canonical-name') is not sufficient for determining if two names
identify the same file.

I think one issue is hardlinks; a file can have two distinct truenames
because of hardlinks, but the attributes contain the uid and the inode
number, which will identify the actual file.

I'm not clear on why a special handler for file-equal-p is needed; is
that just an optimization? file-truename respects file handlers.


This changes Option 2 as indicated below.

Stephen Leake <stephen_leake@HIDDEN> writes:

> To summarize:
>
> The problem is comparing xrefs directly (for sorting and testing),
> comparing the result of xref-location-group (for sorting), and possibly
> comparing results of other xref access functions in the future. Note
> that any filenames in xrefs identify existing files, except in
> artifically constructed tests.
>
> I believe the two alternatives being proposed are:
>
> 1) Use `file-equal-p'
>
> - Provide a cl-defgeneric `xref-location-equal-p' for the root
>   xref-location type.
>
> - For each type that inherits from xref-location, provide an
>   implementation of `xref-location-equal-p' that uses `file-equal-p' for
>   each file name.
>
> - Provide a cl-defmethod `xref-equal-p' for the root xref type that uses
>   `xref-location-equal-p' for the location.
>
> - For each type that inherits from xref, provide an implementation of
>   `xref-equal-p' that uses `xref-location-equal-p' for each location.
>
>
> 2) Use `file-canonical-name'

This changes to "Use `file-truename'.

> - A canonical file name has the following features:
>
>   It contains forward slashes for directory separators.
>
>   If the file name identifies an existing file, the canonical file name
>   casing matches the actual file name casing. If not, the case of the
>   portions of the canonical file name that do not exist is arbitrary.
>   Note that this matters only on case-insensitive file systems.

I believe this is true of the result of file-truename, and it could be
added to the docstring for that function.

The following two points cannot be satisfied in the presence of
hardlinks, and possibly other issues with file handlers; so they are deleted.

>   Two different non-canonical names for an existing file convert to the
>   same canonical file name. Note that this means symlinks are resolved.
>
>   Canonical file names may be compared with `string-equal' and
>   `string-lessp'.

> - Provide a system-dependent `file-canonical-name' that converts
>   user-provided file names to a canonical file name.

This is deleted.


> - Require each variant of make-xref-location to use it for file name
>   slots.

"it" now means "file-truename".

> Option 1) solves the problem of comparing xrefs and xref-locations, but
> does not solve the problem of comparing results of
> xref-location-group.

This remains true. And since xref--analyze compares the result of
xref-location-group, it is not just a theoretical problem; I provided an
example where it fails.

> Option 2) solves the problems of comparing xrefs, xref-locations,
> results of xref-location-group, and results of future xref access
> functions.

This is true only if there are no hard links (or other issues with file
handlers). 

> So far, `file-truename' seems adequate for `file-canonical-name', but it
> might be best to define the alias, in case we find problems in the
> future.

This is not true; I'm now convinced it is not possible to define a fully
correct `file-canonical-name'.

Hmm. If there is a way to iterate all the truenames for a file (I didn't
find one), then we could order them with string-lessp, and simply take
the first as the canonical name. I'm not sure that would be really
useful.

> Option 2) seems better to me. 

This remains true. If there are hardlinks on the disk, users will just
have to be aware of that, and cope. That's no worse than the current
situation.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 16:08:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 11:08:29 2015
Received: from localhost ([127.0.0.1]:53519 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu0bt-0004VZ-6b
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 11:08:29 -0500
Received: from mtaout24.012.net.il ([80.179.55.180]:48990)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Zu0bn-0004VL-Ov
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 11:08:27 -0500
Received: from conversion-daemon.mtaout24.012.net.il by mtaout24.012.net.il
 (HyperSendmail v2007.08) id <0NXA00800SBROM00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 18:01:41 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout24.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NXA007LBSITWS20@HIDDEN>; Wed, 04 Nov 2015 18:01:41 +0200 (IST)
Date: Wed, 04 Nov 2015 18:08:20 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <8637wmyw2e.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83si4lu4qz.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: 8BIT
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
 <8637wmyw2e.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, flexibeast@HIDDEN,
 dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Date: Wed, 04 Nov 2015 03:04:41 -0600
> Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org,
> 	Dmitry Gutov <dgutov@HIDDEN>
> 
> Windows 8.1 lets me create:
> 
> "c:/tmp/STRAẞE.text" ;; LATIN CAPITAL LETTER SHARP S
> "c:/tmp/Straße.text" ;; LATIN SMALL LETTER SHARP S
> "c:/tmp/Strasse.text"

Windows is right: ẞ is not the upper-case variant of ß.  See
UnicodeData.txt and SpecialCasing.txt.

> Perhaps Windows has simply not yet implemented this recent addition to
> Unicode?

It's not recent: it appeared in Unicode 5.1, 7 years ago.

> Debian testing (a few months old) running in VMWare under Windows 8.1
> shows the same behavior. But Debian is case-sensitive, so that's not an
> issue here, I think. The upcase/downcase is wrong, but I'm guessing
> that's due to the CAPITAL being a recent addition to Unicode. 

No, it's because Unicode doesn't say these two letters are a case
pair, at least not in the usual sense.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 15:40:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 10:40:35 2015
Received: from localhost ([127.0.0.1]:53503 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu0As-0003ph-Kg
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:40:35 -0500
Received: from mtaout27.012.net.il ([80.179.55.183]:51462)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Zu0Aq-0003pV-5q
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:40:32 -0500
Received: from conversion-daemon.mtaout27.012.net.il by mtaout27.012.net.il
 (HyperSendmail v2007.08) id <0NXA00800R8Y3G00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 17:34:16 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout27.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NXA0042IR945B20@HIDDEN>; Wed, 04 Nov 2015 17:34:16 +0200 (IST)
Date: Wed, 04 Nov 2015 17:38:55 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87ziyunuj3.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Random832 <random832@HIDDEN>
Message-id: <83wptxu640.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: 8BIT
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
 <87ziyunuj3.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Random832 <random832@HIDDEN>
> Date: Wed, 04 Nov 2015 01:33:20 -0500
> 
> Fsvo "typically". On Emacs, and in Windows filenames [fortuitously, they
> match in this case. Unfortunately, I don't believe there's an easy way
> to get at the table used in Windows], upcasing is done on a
> character-by-character basis, and AIUI neither of them do this, so
> (string= (upcase "Straße") "STRAßE").

Btw, patches to support what Unicode's SpecialCasing.txt describes are
welcome.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 15:36:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 10:36:07 2015
Received: from localhost ([127.0.0.1]:53494 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu06Z-0003ie-3A
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:36:07 -0500
Received: from mtaout28.012.net.il ([80.179.55.184]:35446)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Zu06D-0003hZ-R7
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:36:04 -0500
Received: from conversion-daemon.mtaout28.012.net.il by mtaout28.012.net.il
 (HyperSendmail v2007.08) id <0NXA00L00R5UXY00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 17:34:30 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout28.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NXA00KCWR9HH010@HIDDEN>; Wed, 04 Nov 2015 17:34:30 +0200 (IST)
Date: Wed, 04 Nov 2015 17:35:34 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87r3k6uuhc.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Alexis <flexibeast@HIDDEN>
Message-id: <83ziytu69l.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: 8BIT
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
 <87ziyunuj3.fsf@HIDDEN> <87r3k6uuhc.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: random832@HIDDEN, 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Alexis <flexibeast@HIDDEN>
> Date: Wed, 04 Nov 2015 17:52:31 +1100
> Cc: 21816 <at> debbugs.gnu.org
> 
>     (string<? "z" "ß") => #t (string<? "z" "zz") => #t (string<? 
>     "z" "Z") => #f (string=? "Straße" "Strasse") => #f 
>  
>     (string-upcase "Hi") => "HI" (string-downcase "Hi") => "hi" 
>     (string-foldcase "Hi") => "hi" 
>  
>     (string-upcase "Straße") => "STRASSE" (string-downcase 
>     "Straße") => "straße" (string-foldcase "Straße") => "strasse" 
>     (string-downcase "STRASSE")  => "strasse"

That's locale-dependent (I'm guessing your locale uses the UTF-8
codeset and your system is glibc-based), whereas Emacs's case
conversions are independent of the current locale.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 15:35:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 10:35:49 2015
Received: from localhost ([127.0.0.1]:53491 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu06G-0003hl-G4
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:35:48 -0500
Received: from mtaout24.012.net.il ([80.179.55.180]:47812)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Zu05v-0003hG-FM
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:35:46 -0500
Received: from conversion-daemon.mtaout24.012.net.il by mtaout24.012.net.il
 (HyperSendmail v2007.08) id <0NXA00I00QRFB600@HIDDEN> for
 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 17:27:23 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout24.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NXA00DS0QXNQX40@HIDDEN>; Wed, 04 Nov 2015 17:27:23 +0200 (IST)
Date: Wed, 04 Nov 2015 17:34:03 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87si4muyk4.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Alexis <flexibeast@HIDDEN>
Message-id: <831tc5vkwk.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: 8BIT
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN,
 dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Alexis <flexibeast@HIDDEN>
> Date: Wed, 04 Nov 2015 16:24:27 +1100
> Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org,
> 	Dmitry Gutov <dgutov@HIDDEN>
> 
>     I did not try a non-ASCII file name; I'm not sure how to construct one that has a non-ASCII casing issue. 
> 
> Perhaps use German Eszett / sharp S / Unicode LATIN SMALL LETTER SHARP S? The words 'Strasse' and 'Straße' are equivalent, but typically the latter is up-cased to 'STRASSE', rather than 'STRAẞE'. (Indeed, LATIN CAPITAL LETTER SHARP S was only added to Unicode in version 5.1.) In turn, 'STRASSE' is typically down-cased to 'strasse'. Further, even the latest version of Unicode notes that SpecialCasing.txt doesn't handle this situation: 

Thanks for bringing up this problematic issue.  However, this issue is
not relevant to file names, at least not on MS-Windows, because
Windows doesn't consider this case conversion either:

  (file-exists-p "Straße.txt")
   => t
  (file-exists-p "straße.txt")
   => t
  (file-exists-p "STRAßE.TXT")
   => t
  (file-exists-p "STRASSE.txt")
   => nil





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 15:30:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 10:30:09 2015
Received: from localhost ([127.0.0.1]:53482 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zu00m-0003Yb-Ds
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:30:09 -0500
Received: from gproxy7-pub.mail.unifiedlayer.com ([70.40.196.235]:50791)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Zu00i-0003YG-Vu
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 10:30:07 -0500
Received: (qmail 15111 invoked by uid 0); 4 Nov 2015 15:30:02 -0000
Received: from unknown (HELO cmgw3) (10.0.90.84)
 by gproxy7.mail.unifiedlayer.com with SMTP; 4 Nov 2015 15:30:01 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw3 with 
 id dZVv1r00D2UdiVW01ZVy03; Wed, 04 Nov 2015 14:30:00 -0700
X-Authority-Analysis: v=2.1 cv=Zs1+dbLG c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=pGLkceISAAAA:8 a=Ec5QilWg2r_Xta9yjdEA:9
Received: from [76.218.37.33] (port=57064 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Zu00a-00057k-Lr; Wed, 04 Nov 2015 08:29:56 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Juanma Barranquero <lekktu@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
Date: Wed, 04 Nov 2015 09:29:42 -0600
In-Reply-To: <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 (Juanma Barranquero's message of "Tue, 3 Nov 2015 11:06:57 +0100")
Message-ID: <86pozpye8p.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Juanma Barranquero <lekktu@HIDDEN> writes:

> ... though I get a whole bunch of warnings running the
> test:
>
> c:/devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el and
> c:/Devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el are the same
> file

Perhaps it would be appropriate to delete the code that generates this
warning.

If the policy is that `load-path' may contain directory names that are
different from the disk name, then taking advantage of that should not
produce warnings.

But that discussion should move to a separate bug/subject.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 10:37:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 05:37:28 2015
Received: from localhost ([127.0.0.1]:52305 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtvRY-00033Y-0Q
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 05:37:28 -0500
Received: from mail-pa0-f44.google.com ([209.85.220.44]:33209)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <flexibeast@HIDDEN>) id 1ZtvRE-00032u-K5
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 05:37:27 -0500
Received: by pabfh17 with SMTP id fh17so49827442pab.0
 for <21816 <at> debbugs.gnu.org>; Wed, 04 Nov 2015 02:37:08 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=references:from:to:cc:subject:in-reply-to:date:message-id
 :mime-version:content-type:content-transfer-encoding;
 bh=7bGObAKBFSo+OhkeNW45I2FwkxFn/HmLz9dm6TKGpJE=;
 b=ylq29ofu3Js7YlDpD2qOe6UsgC8tUNG14dtUpTPdIHEUmVbxhXo8BrhYFWxw9OOYyp
 27CGpBrr8VK6+VTfbDl3+xH98lIB9IyM1k5WeqT89o6QlXDC6StF8hUDnuVMgLW1AUja
 LqWpf9JDb1vFIsxw2V+YOcL/Jch7F1ApcOLhRZSUJkz0t+AhEX43tZzYKDpJyTqHUH7l
 QHaFBfafbHeZUQlxxTAUWdINUp4sn0rrFNCFN+dyMgVBGw2n5W/x79qpS6MxDOsrr+DL
 OKT8dl1+dV1jSVwJ0I+NeOsAkeuXbaiBVIRYJNAw3ElY3ZoJt/qMz3LQFiIt4ng1SNX+
 SCwQ==
X-Received: by 10.68.208.100 with SMTP id md4mr870775pbc.155.1446633427920;
 Wed, 04 Nov 2015 02:37:07 -0800 (PST)
Received: from localhost (CPE-58-161-15-29.cqqy2.win.bigpond.net.au.
 [58.161.15.29])
 by smtp.gmail.com with ESMTPSA id i8sm1227507pbq.56.2015.11.04.02.37.05
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Wed, 04 Nov 2015 02:37:06 -0800 (PST)
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
 <8637wmyw2e.fsf@HIDDEN>
From: Alexis <flexibeast@HIDDEN>
To: stephen_leake@HIDDEN
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <8637wmyw2e.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 21:37:02 +1100
Message-ID: <87pozquk35.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)


Stephen Leake <stephen_leake@HIDDEN> writes:

> I think changing CAPITAL ẞ to "SS" is not strictly a "casing" 
> issue?

Oh, no, it is; a capital Eszett is not at all undebatedly 
canonical. E.g. Wikipedia calls capital Eszett 'contestable':

    https://en.wikipedia.org/wiki/Capital_%E1%BA%9E

This page:

    http://sites.psu.edu/gotunicode/2008/07/18/a_new_german_unicode_letter_ca/

has some more details, including noting that:

    "[i]n official German spelling convention, there is NO CAPITAL 
    SHARP S."

although in 2010 an exception was made:

    "However, in 2010 the use of the capital sharp s became 
    mandatory in official documentation when writing geographical 
    names in all-caps." 

Though i doubt that /all/ usage patterns have adjusted in response 
to this. Thus, the conservative approach is to assume that 'SS' is 
indeed /the/ capital form of ß. The above Wikipedia page goes on 
to note:

    "As of April 2008, typographers have yet to agree on a 
    standard form for the letter capital ẞ, as they did in 1903 
    when an association of German printers and type foundries 
    agreed on the 'Sulzbacher Form' as standard for the lowercase 
    ß."

Hence the capital Eszett only appearing in Unicode 5.1 - iiuc, due 
to the 2004 proposal arguing for a capital Eszett in Unicode on 
the basis that there are typefaces with a capital Eszett now out 
in the wild - and not appearing at all in ISO-8859-1, even though 
ß is there.


Alexis.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 10:01:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 05:01:28 2015
Received: from localhost ([127.0.0.1]:52295 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztusi-00029e-3y
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 05:01:28 -0500
Received: from gproxy7-pub.mail.unifiedlayer.com ([70.40.196.235]:44150)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Ztuse-00029U-1P
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 05:01:26 -0500
Received: (qmail 12612 invoked by uid 0); 4 Nov 2015 10:01:19 -0000
Received: from unknown (HELO cmgw2) (10.0.90.83)
 by gproxy7.mail.unifiedlayer.com with SMTP; 4 Nov 2015 10:01:19 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw2 with 
 id dN161r00d2UdiVW01N1928; Wed, 04 Nov 2015 03:01:17 -0700
X-Authority-Analysis: v=2.1 cv=Jv9i8qIC c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=mDV3o1hIAAAA:8 a=vaJtXVxTAAAA:8 a=pGLkceISAAAA:8
 a=EJuYU3zaDCIWhTiFjmkA:9
Received: from [76.218.37.33] (port=54512 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZtusO-0005re-9n; Wed, 04 Nov 2015 03:01:08 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <83h9l2vloe.fsf@HIDDEN> <864mh2219i.fsf@HIDDEN>
 <83d1vqv3af.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 04:00:58 -0600
In-Reply-To: <83d1vqv3af.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 04 Nov
 2015 05:42:16 +0200")
Message-ID: <86y4eexew5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Stephen Leake <stephen_leake@HIDDEN>
>> Cc: dgutov@HIDDEN,  lekktu@HIDDEN,  21816 <at> debbugs.gnu.org
>> Date: Tue, 03 Nov 2015 15:58:49 -0600
>> 
>> Eli Zaretskii <eliz@HIDDEN> writes:
>> 
>> >> From: Stephen Leake <stephen_leake@HIDDEN>
>> >> Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii
>> >> <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org
>> >> Date: Tue, 03 Nov 2015 13:54:21 -0600
>> >> 
>> >>    If the file name identifies an existing file, convert the file name
>> >>    casing to match the actual file name casing. If not, no case
>> >>    conversion is done.
>> >
>> > For existing files we have file-equal-p, which is more general.  
>> 
>> You missed the context; we have switched from discussing how to compare
>> file names to how to canonicalize a file name, in order to simplify the
>> comparison.
>
> I'm still trying to convince you that this is a dead end: you cannot
> trust user-extensible code to comply with such requirements, on
> filesystems where "canonicalized file name" is not well defined.

We can provide a `file-canonical-name' that does something useful on all
systems.

I believe the notion of "canonical file name" is well defined for
existing files on all systems we care about; is that not true?

For non-existing files, I don't think there is a real problem in
practice (see other email); can you present a use case where there is?


The file-equal-p option does not fix the problem in xref--analyze, since
that is comparing the result of `xref-location-group', which is yet more
user-extensible code; for xref-elisp-location, that is the file name
slot of the location. Using file-canonical-name in xref-location-group
implemetations would fix this; using it in make-xref-location fixes it
in a more robust and consistent way.


To summarize:

The problem is comparing xrefs directly (for sorting and testing),
comparing the result of xref-location-group (for sorting), and possibly
comparing results of other xref access functions in the future. Note
that any filenames in xrefs identify existing files, except in
artifically constructed tests.

I believe the two alternatives being proposed are:

1) Use `file-equal-p'

- Provide a cl-defgeneric `xref-location-equal-p' for the root
  xref-location type.

- For each type that inherits from xref-location, provide an
  implementation of `xref-location-equal-p' that uses `file-equal-p' for
  each file name.

- Provide a cl-defmethod `xref-equal-p' for the root xref type that uses
  `xref-location-equal-p' for the location.

- For each type that inherits from xref, provide an implementation of
  `xref-equal-p' that uses `xref-location-equal-p' for each location.


2) Use `file-canonical-name'

- A canonical file name has the following features:

  It contains forward slashes for directory separators.

  If the file name identifies an existing file, the canonical file name
  casing matches the actual file name casing. If not, the case of the
  portions of the canonical file name that do not exist is arbitrary.
  Note that this matters only on case-insensitive file systems.

  Two different non-canonical names for an existing file convert to the
  same canonical file name. Note that this means symlinks are resolved.

  Canonical file names may be compared with `string-equal' and
  `string-lessp'.

- Provide a system-dependent `file-canonical-name' that converts
  user-provided file names to a canonical file name.

- Require each variant of make-xref-location to use it for file name
  slots.


Option 1) solves the problem of comparing xrefs and xref-locations, but
does not solve the problem of comparing results of xref-location-group.

Option 2) solves the problems of comparing xrefs, xref-locations,
results of xref-location-group, and results of future xref access
functions.

So far, `file-truename' seems adequate for `file-canonical-name', but it
might be best to define the alias, in case we find problems in the
future.

One problem with canonical file names is that the user can construct two
names for a non-existing file that differ only in case; they are
supposed to convert to the same canonical file name on a
case-insensitive file system, but `file-canonical-name' has no way to
know which might represent an actual file in the future. One solution is
for `file-canonical-name' to downcase the portions of the file name that
do not exist, but that's not very user-friendly (`file-truename' does
not do this). This problem does not seem likely to occur in practice.


Option 2) seems better to me. 

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 09:05:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 04:05:06 2015
Received: from localhost ([127.0.0.1]:52262 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztu0A-0000py-1F
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 04:05:06 -0500
Received: from gproxy10-pub.mail.unifiedlayer.com ([69.89.20.226]:59525)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Ztu06-0000pT-2s
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 04:05:03 -0500
Received: (qmail 16087 invoked by uid 0); 4 Nov 2015 09:04:58 -0000
Received: from unknown (HELO CMOut01) (10.0.90.82)
 by gproxy10.mail.unifiedlayer.com with SMTP; 4 Nov 2015 09:04:58 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by CMOut01 with 
 id dM4r1r00C2UdiVW01M4uK9; Wed, 04 Nov 2015 02:04:57 -0700
X-Authority-Analysis: v=2.1 cv=VOBOwb/X c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=IkcTkHD0fZMA:10 a=hEr_IkYJT6EA:10
 a=x_XPkuGwIRMA:10 a=qtqOOiqGOCEA:10 a=pGLkceISAAAA:8 a=qc7CYkaQnKJyZfi3wdYA:9
 a=QEXdDO2ut3YA:10
Received: from [76.218.37.33] (port=54078 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Zttzw-0003FB-67; Wed, 04 Nov 2015 02:04:52 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Alexis <flexibeast@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 03:04:41 -0600
In-Reply-To: <87si4muyk4.fsf@HIDDEN> (Alexis's message of "Wed, 04 Nov 2015
 16:24:27 +1100")
Message-ID: <8637wmyw2e.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Alexis <flexibeast@HIDDEN> writes:

> Stephen Leake <stephen_leake@HIDDEN> writes:
>
>> I did not try a non-ASCII file name; I'm not sure how to construct
>> one that has a non-ASCII casing issue.
>
> Perhaps use German Eszett / sharp S / Unicode LATIN SMALL LETTER SHARP
> S? The words 'Strasse' and 'Stra=C3=9Fe' are equivalent, , but typically =
the
> latter is up-cased to 'STRASSE', rather than 'STRA=E1=BA=9EE'

Windows 8.1 lets me create:

"c:/tmp/STRA=E1=BA=9EE.text" ;; LATIN CAPITAL LETTER SHARP S
"c:/tmp/Stra=C3=9Fe.text" ;; LATIN SMALL LETTER SHARP S
"c:/tmp/Strasse.text"

The font I'm using on Windows has no glyph for LATIN CAPITAL LETTER
SHARP S; on Debian, it's the same glyph as LATIN SMALL LETTER SHARP S,
which is confusing in this context.

file-truename follows Windows:

(file-truename "c:/tmp/Stra=E1=BA=9Ee.text");; CAPITAL
"c:/tmp/STRA=E1=BA=9EE.text";; CAPITAL

(file-truename "c:/tmp/Stra=C3=9Fe.text");; SMALL
"c:/tmp/Stra=C3=9Fe.text";; SMALL

(file-truename "c:/tmp/Strasse.text")
"c:/tmp/Strasse.text"

As do upcase, downcase:
(upcase "Stra=C3=9Fe.text") ;; SMALL
"STRA=C3=9FE.TEXT" ;; SMALL

(downcase "Stra=E1=BA=9Ee.text") ;; CAPITAL
"stra=E1=BA=9Ee.text" ;; CAPITAL

I think changing CAPITAL =E1=BA=9E to "SS" is not strictly a "casing" issue=
? But
perhaps it should be considered for a canonical file name on a
case-insensitive system?

Perhaps Windows has simply not yet implemented this recent addition to
Unicode? In which case, we need a better example to test with.

Debian testing (a few months old) running in VMWare under Windows 8.1
shows the same behavior. But Debian is case-sensitive, so that's not an
issue here, I think. The upcase/downcase is wrong, but I'm guessing
that's due to the CAPITAL being a recent addition to Unicode.=20

--=20
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 08:54:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 03:54:37 2015
Received: from localhost ([127.0.0.1]:52227 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zttq0-0000ZK-IR
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:54:37 -0500
Received: from mail-lb0-f180.google.com ([209.85.217.180]:34803)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Zttpy-0000ZA-Cw
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:54:35 -0500
Received: by lbbwb3 with SMTP id wb3so10446037lbb.1
 for <21816 <at> debbugs.gnu.org>; Wed, 04 Nov 2015 00:54:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=d90v75sksp+3jCLU7lS0K84KTQVVWB8wsdhZ3/WPSlk=;
 b=zxFWeQumzOqoKZENe1ls3BgyWJTCTDodDP6JDEHjOwOJjo0taTCtcL9XYUMO9t0J1U
 rWC4gxxKcvEavcsnB4BFDNInJONh519e07SxeHIJ5ug+Df2VCjg8qJLA+kYahuBXDADu
 SFDi1DEjeyWu06/LaXuZfDloovyK78oJk1EtBQnMHIc5OAygszkHxGBJZOpevYzB28iy
 FnP03ysnn+YmegbWAFWuciLGP9KVN8RvzHH016x9DO9z681MTTZPr/JFyMAUYxMlQNKO
 ud+5f0ialBcCdoSTB8/I2r0mvyCt1On5aqmRKVwT7C2geE4odMEhyfhi9CxcZSisG0GS
 cKUg==
X-Received: by 10.112.62.194 with SMTP id a2mr214914lbs.80.1446627273466; Wed,
 04 Nov 2015 00:54:33 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Wed, 4 Nov 2015 00:53:53 -0800 (PST)
In-Reply-To: <83lhaevm37.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN> <5638FA88.8050702@HIDDEN>
 <83lhaevm37.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Wed, 4 Nov 2015 09:53:53 +0100
Message-ID: <CAAeL0SSeu3ccK-ucoaTdfLKyH-s+1pem26ZR=qKpP3RA6P1H6g@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c3c46ec1ec390523b3283d
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3c46ec1ec390523b3283d
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 9:56 PM, Eli Zaretskii <eliz@HIDDEN> wrote:
>
> > From: Dmitry Gutov <dgutov@HIDDEN>
>
> > I don't know which solution to pick, and I believe I don't know the
> > problem well enough. We probably don't want to venture into Java-land
> > here, and encapsulate any type of field into its separate data type,
> > with its comparison function. But, well, we could do that.
>
> I hoped Juanma will pick up the gauntlet.

At this point, I don't even know what is being proposed. A file-name data
type (in the cl-defstruct sense) with appropriate canonicalization and
comparison functions?

--001a11c3c46ec1ec390523b3283d
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 9:56 PM, Eli Zaretskii &lt;<a href=
=3D"mailto:eliz@HIDDEN">eliz@HIDDEN</a>&gt; wrote:<br>&gt;<br>&gt; &gt; F=
rom: Dmitry Gutov &lt;<a href=3D"mailto:dgutov@HIDDEN">dgutov@HIDDEN<=
/a>&gt;<br>&gt;<br><div>&gt; &gt; I don&#39;t know which solution to pick, =
and I believe I don&#39;t know the<br>&gt; &gt; problem well enough. We pro=
bably don&#39;t want to venture into Java-land<br>&gt; &gt; here, and encap=
sulate any type of field into its separate data type,<br>&gt; &gt; with its=
 comparison function. But, well, we could do that.<br>&gt;<br>&gt; I hoped =
Juanma will pick up the gauntlet.<br><br></div><div>At this point, I don&#3=
9;t even know what is being proposed. A file-name data type (in the cl-defs=
truct sense) with appropriate canonicalization and comparison functions?</d=
iv></div>

--001a11c3c46ec1ec390523b3283d--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 08:49:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 03:49:28 2015
Received: from localhost ([127.0.0.1]:52208 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zttl2-0000RX-Fd
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:49:28 -0500
Received: from mail-lf0-f44.google.com ([209.85.215.44]:34101)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Zttl0-0000RO-EI
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:49:27 -0500
Received: by lfgh9 with SMTP id h9so37002274lfg.1
 for <21816 <at> debbugs.gnu.org>; Wed, 04 Nov 2015 00:49:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=6KGsl/t9BmSEbwPLjdC+/Lbn/AW9VQs1WfHsAE0q/6w=;
 b=qyYsgxSs6GOpNvp2jyoe+8WWUQOOml4zKKM3cP2+zixmxK+6EidGDoUkVdQcs2h1MA
 Mm98Vg1MsMpkFGVJ8PZK0xvrXObx5o+N0ePQrENAOSyMKN/PJAusn0AYntm8jL+KKgIH
 fIQlpwJEmT2tiM9ulLaZw4apa+HOxD6Eoi6OBRwyeRPJCXQA3ZZMFVZVcVofPHgyqhWV
 zZhOJVuA72UJxD3/VoCVVoCFJEZkiV1U6XMrqsIjYy/dVDfbALkVl4mEsRAlGhdg4YMh
 BDeI1ODAxL/GuAWQW2cJw9khAWm8Ye/WE495w4ItJFmAeLgxLTJtFdkfV9o0UjBObCGq
 BKqw==
X-Received: by 10.25.16.195 with SMTP id 64mr12379lfq.62.1446626965264; Wed,
 04 Nov 2015 00:49:25 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Wed, 4 Nov 2015 00:48:45 -0800 (PST)
In-Reply-To: <86lhae27ib.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN>
 <CAAeL0SQJhbhwOPyQWPmEj8f5X=gAxrTRdQhtEAksLRAknHP8Fw@HIDDEN>
 <86lhae27ib.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Wed, 4 Nov 2015 09:48:45 +0100
Message-ID: <CAAeL0SRVjifmkCoVA=MBLWwqEagY6Jk2cM+S9m1cgaEMXP60Kw@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
Content-Type: multipart/alternative; boundary=001a113fb984631dd90523b316ac
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a113fb984631dd90523b316ac
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 8:43 PM, Stephen Leake <
stephen_leake@HIDDEN> wrote:

> You asked about "sorting xrefs"; the only sorting that is currently done
> is in xref--analyze, which groups xrefs with the same filename.

I suppose I view xrefs as potentially more general (a "bookmarkish"
object), while they are in fact designed for a very specific purpose that
doesn't need equality tests or total ordering.

--001a113fb984631dd90523b316ac
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 8:43 PM, Stephen Leake &lt;<a href=
=3D"mailto:stephen_leake@HIDDEN">stephen_leake@HIDDEN</=
a>&gt; wrote:<br><br><div>&gt; You asked about &quot;sorting xrefs&quot;; t=
he only sorting that is currently done<br>&gt; is in xref--analyze, which g=
roups xrefs with the same filename.<br><br></div><div>I suppose I view xref=
s as potentially more general (a &quot;bookmarkish&quot; object), while the=
y are in fact designed for a very specific purpose that doesn&#39;t need eq=
uality tests or total ordering.<br></div><div><br></div></div>

--001a113fb984631dd90523b316ac--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 08:41:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 03:41:25 2015
Received: from localhost ([127.0.0.1]:52204 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZttdF-0000GR-6i
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:41:25 -0500
Received: from mail-lb0-f179.google.com ([209.85.217.179]:36582)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Zttct-0000Fw-7i
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:41:22 -0500
Received: by lbjm5 with SMTP id m5so10256618lbj.3
 for <21816 <at> debbugs.gnu.org>; Wed, 04 Nov 2015 00:41:02 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=0ffjfOeAcmhS6M87oxXqykbsXKtpFq35ysEYB7Vf2Zo=;
 b=yzFHZOdRp/Xea1menZEzJzu3365njYBF6zDLu72MuiaLfeCouCEEsQzlPvtr0drAOY
 ndQEBPccWiTVzWuYAUUt8JREag/LkFKDd04REb4NPFtF08e65Hz91f36KVNyk8sjfpmH
 3pUjvCrgH4I3lXQ97Zj63h/9LbLkne75QbUmRG3POG3d8sTGPEX9/c/nAMtUHd7OQwQB
 6HG3YJOBII3iKxDvjQA1Wb7jFi+Kze32IOx1Dzm9D1MOUbX7amwOoCbC8X734qfy0We/
 MuBXgRGgp4mpfo0B20w/ydlnA0vGzHe2a3I6Q161diDuh5f9UI0+elGjR0ojMVCFDIvW
 4DlQ==
X-Received: by 10.112.61.226 with SMTP id t2mr172730lbr.11.1446626462217; Wed,
 04 Nov 2015 00:41:02 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Wed, 4 Nov 2015 00:40:22 -0800 (PST)
In-Reply-To: <5638F91B.1060601@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN>
 <CAAeL0ST8DJfTG1EZ1i0TviwchLmxJmHMGb-gB06k5Hg_CRAdOw@HIDDEN>
 <5638F91B.1060601@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Wed, 4 Nov 2015 09:40:22 +0100
Message-ID: <CAAeL0SSexCsPs61vHk6TMGWDh9XG4ZxsKv7ExZo7cq7RCch3Pw@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Dmitry Gutov <dgutov@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c3eebc673e8f0523b2f86e
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3eebc673e8f0523b2f86e
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 7:12 PM, Dmitry Gutov <dgutov@HIDDEN> wrote:

> Maybe they would, but you already understand that it's not a realistic
example.  Anything
> they might want to store in the properties, they can store inside their
xref-derived instance.

Yup. Though, there's this comment at the beginning of xref.el:

;; Each identifier must be represented as a string.  Implementers can
;; use string properties to store additional information about the
;; identifier, [...]

> When we add a new generic function, it's good to document exactly what is
expected
> of its implementations. Which is hard to do without knowing use cases.

I've stopped arguing for a generic comparison function (I've read the rest
of the thread and it's obvious that Stephen and you don't consider it
useful). But as a general comment, I disagree with this. A generic
function, in most languages or frameworks that define interfaces, do not
document "exactly" what is expected of the implementations. They document
the behavior in general terms. Which in this case would be: "Compare two
xref-location items and return non-nil if they are considered equal, nil
otherwise." That's *all* a generic comparison function for xref-location
should need to document.

> Why *-tests.el? Canonicalization should happen inside the constructor
function, if anywhere. E.g. inside xref-make-file-location and
xref-make-elisp-location.

I though "solved as above" meant Stephen's fix for this particular bug.

--001a11c3eebc673e8f0523b2f86e
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 7:12 PM, Dmitry Gutov &lt;<a href=
=3D"mailto:dgutov@HIDDEN">dgutov@HIDDEN</a>&gt; wrote:<br><br><div>&g=
t; Maybe they would, but you already understand that it&#39;s not a realist=
ic example.=C2=A0 Anything</div><div>&gt; they might want to store in the p=
roperties, they can store inside their xref-derived instance.</div><div><br=
></div><div>Yup. Though, there&#39;s this comment at the beginning of xref.=
el:</div><div><br></div><div><div>;; Each identifier must be represented as=
 a string.=C2=A0 Implementers can</div><div>;; use string properties to sto=
re additional information about the</div><div>;; identifier, [...]</div></d=
iv><div><br></div><div>&gt; When we add a new generic function, it&#39;s go=
od to document exactly what is expected</div><div>&gt; of its implementatio=
ns. Which is hard to do without knowing use cases.</div><div><br></div><div=
>I&#39;ve stopped arguing for a generic comparison function (I&#39;ve read =
the rest of the thread and it&#39;s obvious that Stephen and you don&#39;t =
consider it useful). But as a general comment, I disagree with this. A gene=
ric function, in most languages or frameworks that define interfaces, do no=
t document &quot;exactly&quot; what is expected of the implementations. The=
y document the behavior in general terms. Which in this case would be: &quo=
t;Compare two xref-location items and return non-nil if they are considered=
 equal, nil otherwise.&quot; That&#39;s *all* a generic comparison function=
 for xref-location should need to document.</div><div><br></div><div>&gt; W=
hy *-tests.el? Canonicalization should happen inside the constructor functi=
on, if anywhere. E.g. inside xref-make-file-location and xref-make-elisp-lo=
cation.<br><br></div><div>I though &quot;solved as above&quot; meant Stephe=
n&#39;s fix for this particular bug.</div><div><br></div></div>

--001a11c3eebc673e8f0523b2f86e--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 08:29:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 03:29:45 2015
Received: from localhost ([127.0.0.1]:52200 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZttRw-0008R4-Kj
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:29:44 -0500
Received: from gproxy10-pub.mail.unifiedlayer.com ([69.89.20.226]:48123)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZttRb-0008QF-6w
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:29:43 -0500
Received: (qmail 8650 invoked by uid 0); 4 Nov 2015 08:29:20 -0000
Received: from unknown (HELO cmgw2) (10.0.90.83)
 by gproxy10.mail.unifiedlayer.com with SMTP; 4 Nov 2015 08:29:20 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw2 with 
 id dLV91r0042UdiVW01LVCr3; Wed, 04 Nov 2015 01:29:18 -0700
X-Authority-Analysis: v=2.1 cv=Jv9i8qIC c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=mDV3o1hIAAAA:8 a=pGLkceISAAAA:8 a=SafsPe2EJB2TzgL9CyAA:9
Received: from [76.218.37.33] (port=53797 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZttRO-0001Bj-Gh; Wed, 04 Nov 2015 01:29:10 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <83bnbav32x.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 02:28:50 -0600
In-Reply-To: <83bnbav32x.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 04 Nov
 2015 05:46:46 +0200")
Message-ID: <867flyyxq5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Stephen Leake <stephen_leake@HIDDEN>
>> Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii
>> <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org
>> Date: Tue, 03 Nov 2015 16:07:00 -0600
>> 
>> Actually, file-truename works for the cases we've discussed so far:
>> 
>> (file-truename "c:/Projects/emacs/master/lisp/elide-head.el")
>> "c:/Projects/emacs/master/lisp/elide-head.el"
>> 
>> (file-truename "c:\\Projects\\emacs\\master\\lisp\\elide-head.el")
>> "c:/Projects/emacs/master/lisp/elide-head.el"
>> 
>> (file-truename "c:\\projects\\emacs\\master\\lisp\\elide-head.el")
>> "c:/Projects/emacs/master/lisp/elide-head.el"
>
> It seems to work because the part that needs caseless comparison does
> exist.  Try using it on a file name where case differences are in a
> part that doesn't exist on disk, and you will see the problem.

Right. But I think that's not a solvable problem in principle, and not
a significant one in practice. 

The only time we would worry about the canonical name for a file that
does not yet exist is when we are about to create it; why would we then
have two different names for it that need to be compared?

We might be preparing to create a list of files with similar names; in
practice, each one will be created one at a time, at which point the
canonical name is well-defined, and can be compared to the proposed
name of the next file to be created. In fact, the OS "file create" will
do that comparison for us.

Hmm; that does mean the creation could not be done in parallel threads.
Again; not a significant problem in practice.

In tests we might invent non-existing names, but that's a special case
that is easily handled by paying attention to case, or creating the
files in the test.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 08:20:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 03:20:21 2015
Received: from localhost ([127.0.0.1]:52191 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZttIq-0008Ck-PL
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:20:21 -0500
Received: from mail-lb0-f169.google.com ([209.85.217.169]:33334)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZttIo-0008Cc-9A
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 03:20:18 -0500
Received: by lbbkw15 with SMTP id kw15so4127320lbb.0
 for <21816 <at> debbugs.gnu.org>; Wed, 04 Nov 2015 00:20:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=ywfKHzBKz9TRXNzPTaDhqbQtGATrGjLuMU4ZuS5Z2jY=;
 b=CdSNVgjNqJqDe6Bk246MeQU7EUPGF+DVh7NzRX3VANlTw71YWtC8BMhIGBy+qprxAv
 Lp5cmaFMTDGVaLjRt6mYG4Xhk+C3WEhWxywxOQl9uThravRFPNd6oFdM5q7ytB6YiZUY
 NWM5fMUz8BKAzFIsJybUllXHB2JDVJRj1nC1jVFUfZXBEKaFMl650njpBJEst+nGai5x
 bXRlzMy9fngEwkGtYxOdA2uN37f4mRFIPtooPgKzIsv3VBnR3rqau3ZmsxM0DYngOJxV
 llXzy4UMRO7nyGU8IMn53kCQ2pjUvIeZuSCSDmrGJKRB0bFxX8rydeR2tFE2f04k9jrP
 fCkA==
X-Received: by 10.112.72.201 with SMTP id f9mr139826lbv.62.1446625217456; Wed,
 04 Nov 2015 00:20:17 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Wed, 4 Nov 2015 00:19:37 -0800 (PST)
In-Reply-To: <83y4efuiqq.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Wed, 4 Nov 2015 09:19:37 +0100
Message-ID: <CAAeL0SSG46KTbDDgkX5rN4g4b-5HCciu+NzVMwDrrE7D5X0FdA@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c2400035c79e0523b2ae53
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>,
 dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c2400035c79e0523b2ae53
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 5:53 PM, Eli Zaretskii <eliz@HIDDEN> wrote:

> You mean, ref doesn't know that some strings are file names and some
> aren't?  Then how does it know they are strings and not symbols or
> something else?  This is Lisp, not C.

I meant a general-purpose comparison function. You cannot look at a struct
and know which strings are intended as filenames and which ones do not. But
xref-specific comparison functions obviously would.

--001a11c2400035c79e0523b2ae53
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 5:53 PM, Eli Zaretskii &lt;<a href=
=3D"mailto:eliz@HIDDEN">eliz@HIDDEN</a>&gt; wrote:<br><br><div>&gt; You m=
ean, ref doesn&#39;t know that some strings are file names and some<br>&gt;=
 aren&#39;t?=C2=A0 Then how does it know they are strings and not symbols o=
r<br>&gt; something else?=C2=A0 This is Lisp, not C.</div><div><br></div><d=
iv>I meant a general-purpose comparison function. You cannot look at a stru=
ct and know which strings are intended as filenames and which ones do not. =
But xref-specific comparison functions obviously would.</div></div>

--001a11c2400035c79e0523b2ae53--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 06:52:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 01:52:41 2015
Received: from localhost ([127.0.0.1]:52124 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztrw1-0002zE-1y
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:52:41 -0500
Received: from mail-pa0-f50.google.com ([209.85.220.50]:35338)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <flexibeast@HIDDEN>) id 1Ztrvy-0002z5-7f
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:52:38 -0500
Received: by pasz6 with SMTP id z6so44814855pas.2
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 22:52:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=references:from:to:cc:subject:in-reply-to:date:message-id
 :mime-version:content-type:content-transfer-encoding;
 bh=2wtf0PEQ2+5potuHGd+/CKjKcijn5owS75hGPHwTkTI=;
 b=TKFRNPGp9Q+2WHEk+up2/V+8ao4hHd2I6dLL5yeJEncEg6H9GS8gbdU38fVf8iTq4n
 LTmO5Kby4/9juY/I/czv/MBmTICJHddSZIeosfM59tIRQdn6MSdVRfKCWCpGqKJGO3xs
 FMwunLOCl6lsOA+bNbf/J5hUJGe1NcxsFunQP9Spwts8w2sgwN/jDsFqmQ9WxZSUyVTY
 RoNMPL2/p49OMrmbpEU0lETJ9pWjOFDudOEoC6xj5ae/gEf4ZZbQfvfj1BiFvC8iupaT
 cphXs7yn/9yJBrcCJuK2IWOebZepEfN+BhHfOz95NdZ/kk/fpiTUDUDuriNBDXuU3gQs
 tBEg==
X-Received: by 10.66.97.2 with SMTP id dw2mr2519892pab.112.1446619957063;
 Tue, 03 Nov 2015 22:52:37 -0800 (PST)
Received: from localhost (CPE-58-161-15-29.cqqy2.win.bigpond.net.au.
 [58.161.15.29])
 by smtp.gmail.com with ESMTPSA id k10sm33195491pbq.78.2015.11.03.22.52.35
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 22:52:35 -0800 (PST)
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
 <87ziyunuj3.fsf@HIDDEN>
From: Alexis <flexibeast@HIDDEN>
To: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87ziyunuj3.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 17:52:31 +1100
Message-ID: <87r3k6uuhc.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)


Random832 <random832@HIDDEN> writes:

> Alexis <flexibeast@HIDDEN> writes: 
>> Perhaps use German Eszett / sharp S / Unicode LATIN SMALL 
>> LETTER SHARP S? The words 'Strasse' and 'Straße' are 
>> equivalent, but typically the latter is up-cased to 'STRASSE', 
>> rather than 'STRAẞE'.
>
> Fsvo "typically".

Oh, sorry, by "typically", i meant "when writing in German", not 
"when doing case-conversions in computing".

> On Emacs, and in Windows filenames [fortuitously, they match in 
> this case. Unfortunately, I don't believe there's an easy way to 
> get at the table used in Windows], upcasing is done on a 
> character-by-character basis, and AIUI neither of them do this, 
> so (string= (upcase "Straße") "STRAßE").

*nod* A good example of why i think the Eszett might be useful for 
testing any proposed equivalence-relation or canonicalisation code 
- there are a variety of approaches "in the wild" re. TRT. Take 
SRFI 75, for example:

https://www.cs.utah.edu/~mflatt/tmp/srfi-75.html

in the section "String Procedures":

    (string<? "z" "ß") => #t (string<? "z" "zz") => #t (string<? 
    "z" "Z") => #f (string=? "Straße" "Strasse") => #f 
 
    (string-upcase "Hi") => "HI" (string-downcase "Hi") => "hi" 
    (string-foldcase "Hi") => "hi" 
 
    (string-upcase "Straße") => "STRASSE" (string-downcase 
    "Straße") => "straße" (string-foldcase "Straße") => "strasse" 
    (string-downcase "STRASSE")  => "strasse"


Alexis.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Nov 2015 06:34:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 01:34:03 2015
Received: from localhost ([127.0.0.1]:52117 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztrdz-0002Zq-Bv
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:34:03 -0500
Received: from eggs.gnu.org ([208.118.235.92]:55420)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdx-0002ZQ-6r
 for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:34:01 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdw-00012B-4c
 for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:34:00 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:47034)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdw-000127-2h
 for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 01:34:00 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:37188)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdv-0002UA-9W
 for bug-gnu-emacs@HIDDEN; Wed, 04 Nov 2015 01:34:00 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrds-00011p-3J
 for bug-gnu-emacs@HIDDEN; Wed, 04 Nov 2015 01:33:59 -0500
Received: from plane.gmane.org ([80.91.229.3]:48179)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdr-00011a-Tc
 for bug-gnu-emacs@HIDDEN; Wed, 04 Nov 2015 01:33:56 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztrdq-0002v2-BM
 for bug-gnu-emacs@HIDDEN; Wed, 04 Nov 2015 07:33:54 +0100
Received: from c-68-39-146-59.hsd1.in.comcast.net ([68.39.146.59])
 by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
 id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Wed, 04 Nov 2015 07:33:54 +0100
Received: from random832 by c-68-39-146-59.hsd1.in.comcast.net with local
 (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Wed, 04 Nov 2015 07:33:54 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
Date: Wed, 04 Nov 2015 01:33:20 -0500
Lines: 10
Message-ID: <87ziyunuj3.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN> <87si4muyk4.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-68-39-146-59.hsd1.in.comcast.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3 (gnu/linux)
Cancel-Lock: sha1:xqEKhBD8zX04uYFiOyLAlVtDKSo=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)

Alexis <flexibeast@HIDDEN> writes:
> Perhaps use German Eszett / sharp S / Unicode LATIN SMALL LETTER SHARP
> S? The words 'Strasse' and 'Straße' are equivalent, but typically the
> latter is up-cased to 'STRASSE', rather than 'STRAẞE'.

Fsvo "typically". On Emacs, and in Windows filenames [fortuitously, they
match in this case. Unfortunately, I don't believe there's an easy way
to get at the table used in Windows], upcasing is done on a
character-by-character basis, and AIUI neither of them do this, so
(string= (upcase "Straße") "STRAßE").





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 05:24:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 04 00:24:55 2015
Received: from localhost ([127.0.0.1]:52082 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtqZ4-0000pi-UX
	for submit <at> debbugs.gnu.org; Wed, 04 Nov 2015 00:24:55 -0500
Received: from mail-pa0-f47.google.com ([209.85.220.47]:33040)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <flexibeast@HIDDEN>) id 1ZtqYj-0000pF-Vz
 for 21816 <at> debbugs.gnu.org; Wed, 04 Nov 2015 00:24:52 -0500
Received: by pabfh17 with SMTP id fh17so41481570pab.0
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 21:24:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=references:from:to:cc:subject:in-reply-to:date:message-id
 :mime-version:content-type:content-transfer-encoding;
 bh=VKpwb9MJ0/GBHQUsfgysDu6CU/z8v1CZXclDxc0/KyY=;
 b=aS4Rmxt36IzCktB8lcxWX5ePpuDxQb1GDxYyk4MSvd9wh3C21t9lHJASuR4F665mfM
 n5DbP0ZobRu4LWTTdME9L78580oZLgBu8Vz7dxQNbOuKteyBnI7HYgEXQDVsrFPFkh33
 eOwhMDFyPKIRNYDSsRYsitiNfSVgv5vlEhu02DUk9sDqFIavdiSDWEGRKgpbL7zRSgoE
 dGrG13mBcAa6jpyN8bnivUGcViEFbmq/8FRiySK4slEI5JCZdZIkeHz1opUOeFIeEZ8r
 RZEPORRwyLM+Cxylt0eN1sJnkY2mP2KQBB1aYZdzsHp2WltZJMLiJi09V0tztvUkLt7V
 b+Aw==
X-Received: by 10.68.197.9 with SMTP id iq9mr38317386pbc.123.1446614673055;
 Tue, 03 Nov 2015 21:24:33 -0800 (PST)
Received: from localhost (CPE-58-161-15-29.cqqy2.win.bigpond.net.au.
 [58.161.15.29])
 by smtp.gmail.com with ESMTPSA id in6sm32632814pbd.86.2015.11.03.21.24.31
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 21:24:31 -0800 (PST)
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN>
From: Alexis <flexibeast@HIDDEN>
To: Stephen Leake <stephen_leake@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <86wptyzqij.fsf@HIDDEN>
Date: Wed, 04 Nov 2015 16:24:27 +1100
Message-ID: <87si4muyk4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)


Stephen Leake <stephen_leake@HIDDEN> writes:

> I did not try a non-ASCII file name; I'm not sure how to 
> construct one that has a non-ASCII casing issue.

Perhaps use German Eszett / sharp S / Unicode LATIN SMALL LETTER 
SHARP S? The words 'Strasse' and 'Straße' are equivalent, but 
typically the latter is up-cased to 'STRASSE', rather than 
'STRAẞE'. (Indeed, LATIN CAPITAL LETTER SHARP S was only added to 
Unicode in version 5.1.) In turn, 'STRASSE' is typically 
down-cased to 'strasse'. Further, even the latest version of 
Unicode notes that SpecialCasing.txt doesn't handle this 
situation:

http://www.unicode.org/versions/Unicode8.0.0/ch03.pdf [p. 81]


Alexis.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 03:46:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 22:46:42 2015
Received: from localhost ([127.0.0.1]:52059 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztp22-0006HO-4J
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:46:42 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:53110)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Ztp20-0006HF-41
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:46:40 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
 a-mtaout22.012.net.il (HyperSendmail v2007.08) id
 <0NX900L00U4WKD00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Wed, 04 Nov 2015 05:46:30 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout22.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900LKDUHHFL50@HIDDEN>;
 Wed, 04 Nov 2015 05:46:30 +0200 (IST)
Date: Wed, 04 Nov 2015 05:46:46 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <86wptyzqij.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83bnbav32x.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Cc: Juanma Barranquero <lekktu@HIDDEN>,  Eli Zaretskii <eliz@HIDDEN>,  21816 <at> debbugs.gnu.org
> Date: Tue, 03 Nov 2015 16:07:00 -0600
> 
> Actually, file-truename works for the cases we've discussed so far:
> 
> (file-truename "c:/Projects/emacs/master/lisp/elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"
> 
> (file-truename "c:\\Projects\\emacs\\master\\lisp\\elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"
> 
> (file-truename "c:\\projects\\emacs\\master\\lisp\\elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"

It seems to work because the part that needs caseless comparison does
exist.  Try using it on a file name where case differences are in a
part that doesn't exist on disk, and you will see the problem.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 4 Nov 2015 03:42:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 22:42:23 2015
Received: from localhost ([127.0.0.1]:52055 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztoxr-0006B4-Dc
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:42:23 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:58782)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtoxW-0006AE-FR
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:42:21 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
 a-mtaout23.012.net.il (HyperSendmail v2007.08) id
 <0NX900G00U6KXJ00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Wed, 04 Nov 2015 05:42:01 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout23.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900G0FUA0SQ70@HIDDEN>;
 Wed, 04 Nov 2015 05:42:01 +0200 (IST)
Date: Wed, 04 Nov 2015 05:42:16 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <864mh2219i.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83d1vqv3af.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <83h9l2vloe.fsf@HIDDEN> <864mh2219i.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Cc: dgutov@HIDDEN,  lekktu@HIDDEN,  21816 <at> debbugs.gnu.org
> Date: Tue, 03 Nov 2015 15:58:49 -0600
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> From: Stephen Leake <stephen_leake@HIDDEN>
> >> Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii
> >> <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org
> >> Date: Tue, 03 Nov 2015 13:54:21 -0600
> >> 
> >>    If the file name identifies an existing file, convert the file name
> >>    casing to match the actual file name casing. If not, no case
> >>    conversion is done.
> >
> > For existing files we have file-equal-p, which is more general.  
> 
> You missed the context; we have switched from discussing how to compare
> file names to how to canonicalize a file name, in order to simplify the
> comparison.

I'm still trying to convince you that this is a dead end: you cannot
trust user-extensible code to comply with such requirements, on
filesystems where "canonicalized file name" is not well defined.

But if you already decided to do this regardless, then I guess it's
time for me to bail out of this discussion.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 23:21:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 18:21:27 2015
Received: from localhost ([127.0.0.1]:51983 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtktK-0008WI-QP
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 18:21:27 -0500
Received: from gproxy4-pub.mail.unifiedlayer.com ([69.89.23.142]:45506)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZtktI-0008W9-Ce
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 18:21:26 -0500
Received: (qmail 27454 invoked by uid 0); 3 Nov 2015 23:21:19 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy4.mail.unifiedlayer.com with SMTP; 3 Nov 2015 23:21:19 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id dBMC1r0022UdiVW01BMFja; Tue, 03 Nov 2015 16:21:19 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=vaJtXVxTAAAA:8 a=HdanrwlU0e8cO87RcFgA:9
Received: from [76.218.37.33] (port=49573 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Ztkt5-0002Nf-TJ; Tue, 03 Nov 2015 16:21:12 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-Reply-To: <86wptyzqij.fsf@HIDDEN> (Stephen Leake's message of
 "Tue, 03 Nov 2015 16:07:00 -0600")
Date: Tue, 03 Nov 2015 16:20:15 -0600
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
Message-ID: <86bnbazn36.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Stephen Leake <stephen_leake@HIDDEN> writes:

> Stephen Leake <stephen_leake@HIDDEN> writes:
>
>> Dmitry Gutov <dgutov@HIDDEN> writes:
>>
>>> On 11/03/2015 09:54 PM, Stephen Leake wrote:
>>>
>>>> I'm not clear how to do the case conversion, but I bet Emacs does have
>>>> the right functions.
>>>
>>> I'd expect file-truename to return an appropriate value, but
>>> apparently not.
>>
>> Right. But it does handle symbolic links; is that what we need for a
>> canonical file name? It is what we want for comparing filenames in
>> xrefs, so it at least needs to be an option.
>
> Actually, file-truename works for the cases we've discussed so far:
>
> (file-truename "c:/Projects/emacs/master/lisp/elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"
>
> (file-truename "c:\\Projects\\emacs\\master\\lisp\\elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"
>
> (file-truename "c:\\projects\\emacs\\master\\lisp\\elide-head.el")
> "c:/Projects/emacs/master/lisp/elide-head.el"
>
> I did not try a non-ASCII file name; I'm not sure how to construct one
> that has a non-ASCII casing issue.

It even works for non-existing files:

(file-truename "c:\\projects\\emacs\\master\\lisp\\foo")
"c:/Projects/emacs/master/lisp/foo"

--
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 22:28:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 17:28:43 2015
Received: from localhost ([127.0.0.1]:51954 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztk4I-0007EB-WA
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:28:43 -0500
Received: from gproxy6-pub.mail.unifiedlayer.com ([67.222.39.168]:42129)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Ztk4G-0007E3-9Z
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:28:41 -0500
Received: (qmail 29959 invoked by uid 0); 3 Nov 2015 22:24:49 -0000
Received: from unknown (HELO cmgw2) (10.0.90.83)
 by gproxy6.mail.unifiedlayer.com with SMTP; 3 Nov 2015 22:24:49 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw2 with 
 id dAQj1r01J2UdiVW01AQmuU; Tue, 03 Nov 2015 15:24:47 -0700
X-Authority-Analysis: v=2.1 cv=Jv9i8qIC c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=S2_vNQ5VacWo3Pf7U_8A:9 a=Bm_gn1ICIww4tRPk:21
 a=rYGfQ3m5HGkeuPWU:21
Received: from [76.218.37.33] (port=65506 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Ztk0T-00034t-9c; Tue, 03 Nov 2015 15:24:45 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Juanma Barranquero <lekktu@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN>
 <CAAeL0SQJhbhwOPyQWPmEj8f5X=gAxrTRdQhtEAksLRAknHP8Fw@HIDDEN>
 <86lhae27ib.fsf@HIDDEN>
Date: Tue, 03 Nov 2015 16:24:35 -0600
In-Reply-To: <86lhae27ib.fsf@HIDDEN> (Stephen Leake's message of
 "Tue, 03 Nov 2015 13:43:56 -0600")
Message-ID: <86h9l2zpp8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Stephen Leake <stephen_leake@HIDDEN> writes:

> You asked about "sorting xrefs"; the only sorting that is currently done
> is in xref--analyze, which groups xrefs with the same filename. It uses
> cl-assoc on the filename, which uses "equal" or "eq" for the string
> comparison, I think. It does have a :test parameter we can use to
> override that.
>
> So that could fail due to filename case sensitivity; I'll see if I can
> construct an example.

Here's a simple example:

(let* ((xref1 (xref-make "(defvar foo"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  "c:/projects/emacs/master/lisp/progmodes/elisp-mode.el")))
       (xref2 (xref-make "(defvar bar"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  "c:/Projects/emacs/master/lisp/progmodes/elisp-mode.el")))
       (xref3 (xref-make "(defvar bar"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  "c:/projects/emacs/master/lisp/progmodes/elisp-mode.el")))
       (alist1 (xref--analyze (list xref1 xref2)))
       (alist2 (xref--analyze (list xref1 xref3))))
  (list (length alist1) (length alist2))
  )

returns (2 1); xref1 and xref2 are not grouped, because the file names
compare not equal.

If xref-make-elisp-location used file-truename, this problem would be fixed:

(let* ((xref1 (xref-make "(defvar foo"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  (file-truename
			   "c:/projects/emacs/master/lisp/progmodes/elisp-mode.el"))))
       (xref2 (xref-make "(defvar bar"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  (file-truename
			  "c:/Projects/emacs/master/lisp/progmodes/elisp-mode.el"))))
       (xref3 (xref-make "(defvar bar"
			 (xref-make-elisp-location
			  'xref-elisp-location 'define-var
			  (file-truename
			  "c:/projects/emacs/master/lisp/progmodes/elisp-mode.el"))))
       (alist1 (xref--analyze (list xref1 xref2)))
       (alist2 (xref--analyze (list xref1 xref3))))
  (list (length alist1) (length alist2))
  )

returns (1 1)
-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 22:18:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 17:18:29 2015
Received: from localhost ([127.0.0.1]:51944 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtjuP-0006z5-6S
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:18:29 -0500
Received: from mail-wm0-f45.google.com ([74.125.82.45]:37873)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1ZtjuM-0006yv-Pl
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:18:27 -0500
Received: by wmff134 with SMTP id f134so26965208wmf.0
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 14:18:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=2RF+TE+rNgvn6bD2CfiPwWOkpvMuqSGU38eSz1nDqF0=;
 b=dTF3WDJNBm1K+bwmGETTOmiYVMF4DogUWpM6i/nOpn/pFpxhZeq9yj2TnwQaihByQK
 hRYUHQ7Ji+wE/EZbeECMOkBbY4wCm3El1R+v6GBFpiNbvZeL5D3R0JfC58fjAxAwdgYR
 vlhDbSKAegxScgn84VPW1RbI72HuPb5hfLBXu4xP0+UcqwyKlYECOKNrHijqzQmU28Xp
 52FIuIcUN2bYIpFVhqx7EQ0SgnitrDN7ZdwNmvk6fKv6ATEdr7lwxxllHGmOEomKS1R/
 NHa8UDnGjPdhCEpe3HPd8rDwA6kgFhMfM9Ft5yV1L7qybnuVKIwJC0CM1ZyDn3rSbNPd
 Q5mA==
X-Received: by 10.28.15.196 with SMTP id 187mr23193329wmp.34.1446589106271;
 Tue, 03 Nov 2015 14:18:26 -0800 (PST)
Received: from [10.9.0.103] (nat.webazilla.com. [78.140.128.228])
 by smtp.googlemail.com with ESMTPSA id w9sm29667493wjf.20.2015.11.03.14.18.24
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 14:18:25 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
 <86wptyzqij.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <563932AF.1010805@HIDDEN>
Date: Wed, 4 Nov 2015 00:18:23 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <86wptyzqij.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/04/2015 12:07 AM, Stephen Leake wrote:

> What test did you run that failed?

I didn't run any real tests (sorry), because I don't have a Windows 
machine at hand. The description in file-truename's docstring just makes 
it look like it's unsuitable for our purpose (but there's a comment in 
its body about delegating to w32-long-file-name).

If it works well, that's great, and makes downcasing issues moot.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 22:07:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 17:07:21 2015
Received: from localhost ([127.0.0.1]:51934 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztjjc-0006hg-SS
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:07:21 -0500
Received: from gproxy5-pub.mail.unifiedlayer.com ([67.222.38.55]:43258)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Ztjja-0006hY-KY
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:07:19 -0500
Received: (qmail 25917 invoked by uid 0); 3 Nov 2015 22:07:14 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy5.mail.unifiedlayer.com with SMTP; 3 Nov 2015 22:07:14 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id dA7B1r0032UdiVW01A7Equ; Tue, 03 Nov 2015 15:07:14 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=vaJtXVxTAAAA:8 a=XcMUEJH0VgTIJJtNwu4A:9
Received: from [76.218.37.33] (port=65382 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZtjjS-00046V-PE; Tue, 03 Nov 2015 15:07:10 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN> <868u6e21kg.fsf@HIDDEN>
Date: Tue, 03 Nov 2015 16:07:00 -0600
In-Reply-To: <868u6e21kg.fsf@HIDDEN> (Stephen Leake's message of
 "Tue, 03 Nov 2015 15:52:15 -0600")
Message-ID: <86wptyzqij.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Stephen Leake <stephen_leake@HIDDEN> writes:

> Dmitry Gutov <dgutov@HIDDEN> writes:
>
>> On 11/03/2015 09:54 PM, Stephen Leake wrote:
>>
>>> I'm not clear how to do the case conversion, but I bet Emacs does have
>>> the right functions.
>>
>> I'd expect file-truename to return an appropriate value, but
>> apparently not.
>
> Right. But it does handle symbolic links; is that what we need for a
> canonical file name? It is what we want for comparing filenames in
> xrefs, so it at least needs to be an option.

Actually, file-truename works for the cases we've discussed so far:

(file-truename "c:/Projects/emacs/master/lisp/elide-head.el")
"c:/Projects/emacs/master/lisp/elide-head.el"

(file-truename "c:\\Projects\\emacs\\master\\lisp\\elide-head.el")
"c:/Projects/emacs/master/lisp/elide-head.el"

(file-truename "c:\\projects\\emacs\\master\\lisp\\elide-head.el")
"c:/Projects/emacs/master/lisp/elide-head.el"

I did not try a non-ASCII file name; I'm not sure how to construct one
that has a non-ASCII casing issue.

What test did you run that failed?

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:59:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:59:28 2015
Received: from localhost ([127.0.0.1]:51919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztjbz-0006UO-MB
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:59:28 -0500
Received: from gproxy9-pub.mail.unifiedlayer.com ([69.89.20.122]:50382)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1Ztjbe-0006Tq-O0
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:59:25 -0500
Received: (qmail 7294 invoked by uid 0); 3 Nov 2015 21:59:03 -0000
Received: from unknown (HELO cmgw3) (10.0.90.84)
 by gproxy9.mail.unifiedlayer.com with SMTP; 3 Nov 2015 21:59:03 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw3 with 
 id dFyx1r00K2UdiVW01Fz0bi; Tue, 03 Nov 2015 20:59:01 -0700
X-Authority-Analysis: v=2.1 cv=Zs1+dbLG c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=mDV3o1hIAAAA:8 a=pGLkceISAAAA:8 a=fY0iefEMjf9Nk1fP2yIA:9
Received: from [76.218.37.33] (port=65330 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZtjbW-00075F-Sa; Tue, 03 Nov 2015 14:58:59 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <83h9l2vloe.fsf@HIDDEN>
Date: Tue, 03 Nov 2015 15:58:49 -0600
In-Reply-To: <83h9l2vloe.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 03 Nov
 2015 23:05:05 +0200")
Message-ID: <864mh2219i.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Stephen Leake <stephen_leake@HIDDEN>
>> Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii
>> <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org
>> Date: Tue, 03 Nov 2015 13:54:21 -0600
>> 
>>    If the file name identifies an existing file, convert the file name
>>    casing to match the actual file name casing. If not, no case
>>    conversion is done.
>
> For existing files we have file-equal-p, which is more general.  

You missed the context; we have switched from discussing how to compare
file names to how to canonicalize a file name, in order to simplify the
comparison.

The rationale here is that it is not possible/easy to always know
whether the string at hand is a file name, but it is always possible (or
at least much easier) to ensure that an xref contains a canonical file
name.

Part of the definition of "canonical file name" must also be:

    Two names for an existing file will convert to canonical filenames
    that will return t from `equal-string'".

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:52:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:52:48 2015
Received: from localhost ([127.0.0.1]:51915 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtjVX-0006Ka-P7
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:52:48 -0500
Received: from gproxy9-pub.mail.unifiedlayer.com ([69.89.20.122]:53752)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZtjVU-0006KQ-Cu
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:52:45 -0500
Received: (qmail 30277 invoked by uid 0); 3 Nov 2015 21:52:40 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy9.mail.unifiedlayer.com with SMTP; 3 Nov 2015 21:52:40 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id d9sb1r0112UdiVW019seg4; Tue, 03 Nov 2015 14:52:40 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=vaJtXVxTAAAA:8 a=xYFpGEdE-2re2PAwpXYA:9
Received: from [76.218.37.33] (port=65290 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZtjVL-0003Qb-9x; Tue, 03 Nov 2015 14:52:35 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-Reply-To: <563913A5.7050403@HIDDEN> (Dmitry Gutov's message of "Tue, 3
 Nov 2015 22:05:57 +0200")
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
Date: Tue, 03 Nov 2015 15:52:15 -0600
Message-ID: <868u6e21kg.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 11/03/2015 09:54 PM, Stephen Leake wrote:
>
>> I'm not clear how to do the case conversion, but I bet Emacs does have
>> the right functions.
>
> I'd expect file-truename to return an appropriate value, but
> apparently not.

Right. But it does handle symbolic links; is that what we need for a
canonical file name? It is what we want for comparing filenames in
xrefs, so it at least needs to be an option.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:25:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:25:17 2015
Received: from localhost ([127.0.0.1]:51892 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztj4v-0005fY-6S
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:25:17 -0500
Received: from mail-wi0-f182.google.com ([209.85.212.182]:36796)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1Ztj4s-0005fP-Cz
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:25:14 -0500
Received: by wicfx6 with SMTP id fx6so77796427wic.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 13:25:13 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=882qlJv6pMQNn1EAZMwRbGL8boloOPvjOTblisGWDXs=;
 b=LqHOqM+KdeWY7w/Z/g8R9pjn+XXECgCOXRTCx2w/xmNQvmQjKPoXdFuqkXsuOCwDdm
 tobFEalOTMCiCgNlHQuqypm2vxJNylHt/mRQg082u3GDu9fdelU/UHzSS0umdAQWHzM4
 EvQpzXxfuIYBXKkcBpe5/rK+T0sLHaDIy3F/eDvsjdBGY5hjk2Hbe17/mV14cRuis5mZ
 dMJ0Xbn6aPB5rqnQzrd7cGVeOdEswaCXADBlTpXAFvD8VLR6WnVzrVL9u5t3MkTMQBiH
 NIAroi4nhUeTxYkXh/7C6c/YZpiYM8o2/zoxxuaFWORDNvnfR3PBNkY/r46DNn6PvQsz
 JJ9A==
X-Received: by 10.194.134.97 with SMTP id pj1mr19880209wjb.106.1446585913792; 
 Tue, 03 Nov 2015 13:25:13 -0800 (PST)
Received: from [10.9.0.103] (nat.webazilla.com. [78.140.128.228])
 by smtp.googlemail.com with ESMTPSA id r12sm25274801wmd.17.2015.11.03.13.25.12
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 13:25:12 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Random832 <random832@HIDDEN>, 21816 <at> debbugs.gnu.org
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN> <5638F966.4050700@HIDDEN>
 <87h9l2voyf.fsf@HIDDEN> <56391328.7050909@HIDDEN>
 <87a8quvnhr.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <56392637.3020307@HIDDEN>
Date: Tue, 3 Nov 2015 23:25:11 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <87a8quvnhr.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 11/03/2015 10:25 PM, Random832 wrote:
> How are you going to canonicalize though?
>
> Case as it exists on the filesystem? What if the file doesn't exist?

Then we have no business using it together with xref.

In any case, we should put a pin in this discussion: equality 
comparison, aside from writing tests, is basically only useful for 
removing duplicates. As far as I know, of course.

This subject has come up before, and the decision at the time was to let 
the function that produces the list of xrefs, remove the duplicates.

Most likely, it's already familiar with what kind of items it's 
returning, the types of their fields, and etc. I understand that may not 
always be true, but we're yet to produce a realistic example of that 
situation.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:22:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:22:43 2015
Received: from localhost ([127.0.0.1]:51887 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztj2Q-0005ap-Mi
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:22:42 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:42862)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Ztj25-0005aJ-QP
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:22:40 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
 a-mtaout23.012.net.il (HyperSendmail v2007.08) id
 <0NX900G00CBC0V00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Tue, 03 Nov 2015 23:22:20 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout23.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900F6GCP8YM50@HIDDEN>;
 Tue, 03 Nov 2015 23:22:20 +0200 (IST)
Date: Tue, 03 Nov 2015 23:22:35 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87611ivl3c.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Random832 <random832@HIDDEN>
Message-id: <83egg6vkv8.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <87lhaevp4q.fsf@HIDDEN> <83io5ivlso.fsf@HIDDEN>
 <87611ivl3c.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Random832 <random832@HIDDEN>
> Date: Tue, 03 Nov 2015 16:17:43 -0500
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> > Not if "canonical" does not tell anything about letter-case or the
> > flavor of slashes.
> 
> It does, because to be canonical it has to be a _single_ sequence of
> characters that is the preferred representation of the object over all
> others. If no such sequence exists, then that means there is no
> canonical form, not that there are two. That's what canonical means.

I don't see how this argument is useful for the issue at hand, so I
won't.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 3 Nov 2015 21:18:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:18:26 2015
Received: from localhost ([127.0.0.1]:51883 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtiyH-0005Tv-Vr
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:18:26 -0500
Received: from eggs.gnu.org ([208.118.235.92]:53457)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyG-0005Tl-C0
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:18:24 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyF-0004gL-Br
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:18:24 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:57727)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyF-0004gG-9I
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:18:23 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:35227)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyE-0002C9-Hn
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 16:18:23 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyB-0004fl-Cu
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 16:18:22 -0500
Received: from plane.gmane.org ([80.91.229.3]:50579)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiyB-0004ff-6K
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 16:18:19 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Ztiy3-0000Fa-K6
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 22:18:11 +0100
Received: from c-68-39-146-59.hsd1.in.comcast.net ([68.39.146.59])
 by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
 id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 22:18:11 +0100
Received: from random832 by c-68-39-146-59.hsd1.in.comcast.net with local
 (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 22:18:11 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
Date: Tue, 03 Nov 2015 16:17:43 -0500
Lines: 8
Message-ID: <87611ivl3c.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <87lhaevp4q.fsf@HIDDEN> <83io5ivlso.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-68-39-146-59.hsd1.in.comcast.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3 (gnu/linux)
Cancel-Lock: sha1:aTDoiv9prTr0lOs6/QeIo8WTHx8=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)

Eli Zaretskii <eliz@HIDDEN> writes:
> Not if "canonical" does not tell anything about letter-case or the
> flavor of slashes.

It does, because to be canonical it has to be a _single_ sequence of
characters that is the preferred representation of the object over all
others. If no such sequence exists, then that means there is no
canonical form, not that there are two. That's what canonical means.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:07:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:07:09 2015
Received: from localhost ([127.0.0.1]:51875 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtinN-0005Ca-Bh
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:07:09 -0500
Received: from mtaout28.012.net.il ([80.179.55.184]:47792)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtinL-0005CS-FT
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:07:08 -0500
Received: from conversion-daemon.mtaout28.012.net.il by mtaout28.012.net.il
 (HyperSendmail v2007.08) id <0NX900O00BJTGR00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 23:06:00 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout28.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900K0OBY0NR50@HIDDEN>; Tue, 03 Nov 2015 23:06:00 +0200 (IST)
Date: Tue, 03 Nov 2015 23:07:21 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <563913A5.7050403@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Dmitry Gutov <dgutov@HIDDEN>
Message-id: <83fv0mvlkm.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
 <563913A5.7050403@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
>  21816 <at> debbugs.gnu.org
> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Tue, 3 Nov 2015 22:05:57 +0200
> 
> On 11/03/2015 09:54 PM, Stephen Leake wrote:
> 
> > I'm not clear how to do the case conversion, but I bet Emacs does have
> > the right functions.
> 
> I'd expect file-truename to return an appropriate value, but apparently not.

file-truename works only for existing files.  See file-equal-p.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:06:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:06:16 2015
Received: from localhost ([127.0.0.1]:51871 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtimV-0005B3-Sn
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:06:16 -0500
Received: from mtaout25.012.net.il ([80.179.55.181]:51492)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtimT-0005Ao-5a
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:06:14 -0500
Received: from conversion-daemon.mtaout25.012.net.il by mtaout25.012.net.il
 (HyperSendmail v2007.08) id <0NX900N00BGY3700@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 23:02:36 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout25.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900H9GBSCGD60@HIDDEN>; Tue, 03 Nov 2015 23:02:36 +0200 (IST)
Date: Tue, 03 Nov 2015 23:05:05 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <86h9l2270y.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83h9l2vloe.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Cc: Juanma Barranquero <lekktu@HIDDEN>,  Eli Zaretskii <eliz@HIDDEN>,  21816 <at> debbugs.gnu.org
> Date: Tue, 03 Nov 2015 13:54:21 -0600
> 
>    If the file name identifies an existing file, convert the file name
>    casing to match the actual file name casing. If not, no case
>    conversion is done.

For existing files we have file-equal-p, which is more general.  The
problem here is that files might not exist, so we need a weaker test
that still does a reasonably good job.

> I'm not clear how to do the case conversion, but I bet Emacs does have
> the right functions.

It does.  Actually, we have more than one such function.

> This does not handle comparing two file names for a not-yet-created file
> that differ in case.

Indeed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:02:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:02:20 2015
Received: from localhost ([127.0.0.1]:51867 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztiii-00055R-2s
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:02:20 -0500
Received: from mtaout24.012.net.il ([80.179.55.180]:56981)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Ztiif-00055I-K6
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:02:18 -0500
Received: from conversion-daemon.mtaout24.012.net.il by mtaout24.012.net.il
 (HyperSendmail v2007.08) id <0NX900600BDT5Q00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:55:37 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout24.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900IAEBGOMZB0@HIDDEN>; Tue, 03 Nov 2015 22:55:37 +0200 (IST)
Date: Tue, 03 Nov 2015 23:02:31 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <87lhaevp4q.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Random832 <random832@HIDDEN>
Message-id: <83io5ivlso.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <87lhaevp4q.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Random832 <random832@HIDDEN>
> Date: Tue, 03 Nov 2015 14:50:29 -0500
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> > Both forms (and some additional ones) are perfectly canonical.
> 
> That is a contradiction in terms. There can only be one canonical
> form.

Not if "canonical" does not tell anything about letter-case or the
flavor of slashes.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 21:00:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 16:00:21 2015
Received: from localhost ([127.0.0.1]:51857 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztigm-00051v-Kh
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:00:21 -0500
Received: from mtaout27.012.net.il ([80.179.55.183]:49331)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Ztigk-00051l-0X
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 16:00:19 -0500
Received: from conversion-daemon.mtaout27.012.net.il by mtaout27.012.net.il
 (HyperSendmail v2007.08) id <0NX900G00B52K600@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:55:38 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout27.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX90093RBGPFW70@HIDDEN>; Tue, 03 Nov 2015 22:55:38 +0200 (IST)
Date: Tue, 03 Nov 2015 23:00:32 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <86pozq28eo.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83k2pyvlvz.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <86pozq28eo.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Cc: lekktu@HIDDEN,  21816 <at> debbugs.gnu.org
> Date: Tue, 03 Nov 2015 13:24:31 -0600
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Sorry to bust this party, guys, but I don't think this solution is
> > "good enough".  
> 
> In general, or just for this test?

Both, IMO.

> Let's fix the test first, and worry about the general case later.

Why not kill two birds with the same stone?

> > First, it won't DTRT with Windows file names that have
> > backslashes (yes, they happen in Emacs).  
> 
> That's easy; add `expand-file-name'.

For this specific case, yes.  But there's no way to be sure no one
will ever use concat or some such.  Or just take default directory and
use it directly.

> > Second, 'downcase' has a known gotcha of using the current buffer's
> > case tables, which is something you definitely don't want here.
> 
> Ah; I had not considered non-ASCII stuff.
> 
> Is there some global variable we can let-bind to control that?

You want with-case-table and standard-case-table, I think.

> > Bottom line, doing this "right" is not so trivial, and a dedicated
> > function is a better solution, IMO.  If you put it in files-x.el, it
> > could be reused by other Lisp programs in the need of this.
> 
> Yes, that makes sense.
> 
> > IME, it doesn't pay off to use such incomplete solutions, the result
> > is an annoying, albeit minor, maintenance burden.  
> 
> Not in this test.

Not today, maybe.  But there's always tomorrow and the day after.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 20:56:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 15:56:00 2015
Received: from localhost ([127.0.0.1]:51825 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztica-0004sw-3G
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:56:00 -0500
Received: from mtaout24.012.net.il ([80.179.55.180]:38598)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZticY-0004so-2z
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:55:58 -0500
Received: from conversion-daemon.mtaout24.012.net.il by mtaout24.012.net.il
 (HyperSendmail v2007.08) id <0NX900400AT80L00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 22:49:17 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout24.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900IAYB65MZA0@HIDDEN>; Tue, 03 Nov 2015 22:49:17 +0200 (IST)
Date: Tue, 03 Nov 2015 22:56:12 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <5638FA88.8050702@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Dmitry Gutov <dgutov@HIDDEN>
Message-id: <83lhaevm37.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <5638FA88.8050702@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Tue, 3 Nov 2015 20:18:48 +0200
> 
> > This isn't a xref-specific problem, so I think it should have a more
> > general solution that any package could use.  It's not reasonable to
> > expect from every Emacs developer to be an expert on subtle aspects of
> > comparing Windows file names.  We should provide a tested solution for
> > that.
> 
> I don't know which solution to pick, and I believe I don't know the 
> problem well enough. We probably don't want to venture into Java-land 
> here, and encapsulate any type of field into its separate data type, 
> with its comparison function. But, well, we could do that.

I hoped Juanma will pick up the gauntlet.

> In any case, it's not a hugely important problem, compared to others we 
> still have.

One step at a time.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 20:51:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 15:51:29 2015
Received: from localhost ([127.0.0.1]:51809 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtiYD-0004lY-7S
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:51:29 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:56784)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtiYA-0004lN-5q
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:51:27 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
 a-mtaout21.012.net.il (HyperSendmail v2007.08) id
 <0NX900K00B2PYF00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Tue, 03 Nov 2015 22:51:24 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout21.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900K46B9OV580@HIDDEN>;
 Tue, 03 Nov 2015 22:51:24 +0200 (IST)
Date: Tue, 03 Nov 2015 22:51:39 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <5638F966.4050700@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Dmitry Gutov <dgutov@HIDDEN>
Message-id: <83r3k6vmas.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN> <5638F966.4050700@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Cc: 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Tue, 3 Nov 2015 20:13:58 +0200
> 
> On 11/03/2015 06:53 PM, Eli Zaretskii wrote:
> 
> > You mean, ref doesn't know that some strings are file names and some
> > aren't?  Then how does it know they are strings and not symbols or
> > something else?  This is Lisp, not C.
> 
> Lisp has a "string" data type. It doesn't have a "file" data type. It's 
> not Java.

File names are not strings.

If we need to know that a string is a file name, we can put some
property on it.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 3 Nov 2015 20:26:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 15:26:30 2015
Received: from localhost ([127.0.0.1]:51789 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtiA2-00048Z-09
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:26:30 -0500
Received: from eggs.gnu.org ([208.118.235.92]:33113)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1ZtiA0-00048S-Aj
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:26:28 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9z-0001TG-6l
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:26:28 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.0 required=5.0 tests=BAYES_20,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:59039)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9z-0001TB-35
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:26:27 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:43097)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9y-0003KV-4i
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 15:26:27 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9u-0001Pt-VU
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 15:26:26 -0500
Received: from plane.gmane.org ([80.91.229.3]:47539)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9u-0001PN-HY
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 15:26:22 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zti9t-0004bc-7p
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 21:26:21 +0100
Received: from c-68-39-146-59.hsd1.in.comcast.net ([68.39.146.59])
 by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
 id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 21:26:21 +0100
Received: from random832 by c-68-39-146-59.hsd1.in.comcast.net with local
 (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 21:26:21 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
Date: Tue, 03 Nov 2015 15:25:52 -0500
Lines: 23
Message-ID: <87a8quvnhr.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN> <5638F966.4050700@HIDDEN>
 <87h9l2voyf.fsf@HIDDEN> <56391328.7050909@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-68-39-146-59.hsd1.in.comcast.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3 (gnu/linux)
Cancel-Lock: sha1:p4dnmX8g2hSMeZaRShutWMloyKk=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 11/03/2015 09:54 PM, Random832 wrote:
>
>> Ideally, any data structure which can be compared and may contain a file
>> name should provide a comparison function which will, if it contains a
>> filename, compare the filenames with a filename comparison function.
>
> There's not much ideal about that. If we could get away with only
> canonicalizing file names, having to write comparison functions
> instead would involve an order of magnitude more code.

How are you going to canonicalize though?

Case as it exists on the filesystem? What if the file doesn't exist?

All upper or lower case? What if the file doesn't exist and the
"canonicalized" path is used to create it, contrary to the user's
intentions?

As it exists for what does exist, then as entered for components that
don't exist? What if the file is created with different cases
afterwards?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 20:06:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 15:06:22 2015
Received: from localhost ([127.0.0.1]:51781 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZthqX-0003fR-JM
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:06:21 -0500
Received: from mail-wm0-f42.google.com ([74.125.82.42]:38422)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1ZthqC-0003eV-Rs
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:06:19 -0500
Received: by wmeg8 with SMTP id g8so24431154wme.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 12:06:00 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=R2ps+Tdhcq/nLuQ9dUzz5p90cbWsxDomyWzm3DGYwRw=;
 b=A4g1wjm88E1k9AoTHni3LW2qfPcPCp+Z8hCGCBQtUIzsxUVxeVP691mF/7SlIwYeYy
 irDuXC5KF3Grs8J48qwCkRk5xR/+7bgxLctEMI3HjXfIGfVPo3x1/m01FgDj5BpfqROQ
 W35n41s7JefSol7nMc3htDIBCOg5jj2lHYyc/s1faX8VUUYqlCvZ5/VmwxbEJWpQJK1G
 zBQU1CofNjan2R/oj+llMzc2uHbCTsxI1vyC82k1q5eE3kL0CDEEFMiLyacT+AgS6vef
 55mgN5h3gk026UBWBi9l6SXwMN9GAzaFvCdZpMmCoFrwDy/oP93A33dPhtZpOdVfP7FG
 T/pw==
X-Received: by 10.28.6.70 with SMTP id 67mr22972076wmg.54.1446581160287;
 Tue, 03 Nov 2015 12:06:00 -0800 (PST)
Received: from [10.9.0.103] (nat.webazilla.com. [78.140.128.228])
 by smtp.googlemail.com with ESMTPSA id s127sm25017026wmb.8.2015.11.03.12.05.58
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 12:05:59 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <86h9l2270y.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <563913A5.7050403@HIDDEN>
Date: Tue, 3 Nov 2015 22:05:57 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <86h9l2270y.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/03/2015 09:54 PM, Stephen Leake wrote:

> I'm not clear how to do the case conversion, but I bet Emacs does have
> the right functions.

I'd expect file-truename to return an appropriate value, but apparently not.

> This does not handle comparing two file names for a not-yet-created file
> that differ in case.

Indeed. We're unlikely to encounter this case with xref, though.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 20:03:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 15:03:59 2015
Received: from localhost ([127.0.0.1]:51777 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZthoF-0003bQ-4u
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:03:59 -0500
Received: from mail-wi0-f172.google.com ([209.85.212.172]:36183)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1ZthoD-0003bI-JS
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 15:03:58 -0500
Received: by wicfx6 with SMTP id fx6so76611645wic.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 12:03:57 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=Z5DaEr0Xsv4ECU/JffAoumLJNOobU6HtCgohhGPDDws=;
 b=av+RP99L4BFq1AEPHnVt1fqMggv1KHNjsdOSfy+gEXfud8ALy0K+7LiuUennqFN3m4
 JVWx1zQ02juTOG/D9+65VBNR1HWfke9tQ2pIERbch0EosghllMtpUN91Kw8lrUmREra7
 K1v+Nh9X4v8s1t7WlqDJSsiUrYQ/KvOtHhE3W3Pi9p2Z/fpsf0monkr17OOc0DB7WUNJ
 IHEfYEIbp0r8/WHsXFXEWOQPDBUSg9cIcvAcF2Af1Wn+4jBjnOqYdc5stoyrfJ0ssIfl
 VatH3LOqCmL7jbDpgAsC/NrB8jDVQ2qtrHr8vLIcLeYUXZrtTEuMXwLGFCu1oNV5ERfJ
 0P4A==
X-Received: by 10.194.116.167 with SMTP id jx7mr36332891wjb.4.1446581036970;
 Tue, 03 Nov 2015 12:03:56 -0800 (PST)
Received: from [10.9.0.103] (nat.webazilla.com. [78.140.128.228])
 by smtp.googlemail.com with ESMTPSA id gl9sm29242132wjb.10.2015.11.03.12.03.55
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 12:03:55 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Random832 <random832@HIDDEN>, 21816 <at> debbugs.gnu.org
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN> <5638F966.4050700@HIDDEN>
 <87h9l2voyf.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <56391328.7050909@HIDDEN>
Date: Tue, 3 Nov 2015 22:03:52 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <87h9l2voyf.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 11/03/2015 09:54 PM, Random832 wrote:

> Ideally, any data structure which can be compared and may contain a file
> name should provide a comparison function which will, if it contains a
> filename, compare the filenames with a filename comparison function.

There's not much ideal about that. If we could get away with only 
canonicalizing file names, having to write comparison functions instead 
would involve an order of magnitude more code.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 3 Nov 2015 19:55:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 14:55:15 2015
Received: from localhost ([127.0.0.1]:51773 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zthfm-0003Nn-UW
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:55:15 -0500
Received: from eggs.gnu.org ([208.118.235.92]:44063)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthfl-0003Nf-GW
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:55:13 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthfk-0000Oj-Ir
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:55:13 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:59855)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthfk-0000Oe-Ge
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:55:12 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:54057)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthfj-0002nB-LF
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:55:12 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthff-0000LK-LP
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:55:11 -0500
Received: from plane.gmane.org ([80.91.229.3]:45402)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthff-0000Ko-FE
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:55:07 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthfc-0002Wj-Rr
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 20:55:04 +0100
Received: from c-68-39-146-59.hsd1.in.comcast.net ([68.39.146.59])
 by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
 id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 20:55:04 +0100
Received: from random832 by c-68-39-146-59.hsd1.in.comcast.net with local
 (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 20:55:04 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
Date: Tue, 03 Nov 2015 14:54:16 -0500
Lines: 18
Message-ID: <87h9l2voyf.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN> <5638F966.4050700@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-68-39-146-59.hsd1.in.comcast.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3 (gnu/linux)
Cancel-Lock: sha1:eJlMpPG6trNk/Rs0qWy3UZw2SYM=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 11/03/2015 06:53 PM, Eli Zaretskii wrote:
>
>> You mean, ref doesn't know that some strings are file names and some
>> aren't?  Then how does it know they are strings and not symbols or
>> something else?  This is Lisp, not C.
>
> Lisp has a "string" data type. It doesn't have a "file" data
> type. It's not Java.

Yes, but that means you should not have any places (variables,
parameters, parts of data structures) where you have a string that may
or may not be a file name with no way of knowing which you want.

Ideally, any data structure which can be compared and may contain a file
name should provide a comparison function which will, if it contains a
filename, compare the filenames with a filename comparison function.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 19:55:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 14:55:01 2015
Received: from localhost ([127.0.0.1]:51769 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZthfZ-0003Mv-88
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:55:01 -0500
Received: from gproxy10-pub.mail.unifiedlayer.com ([69.89.20.226]:42668)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZthfE-0003MU-BM
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:54:59 -0500
Received: (qmail 3817 invoked by uid 0); 3 Nov 2015 19:54:37 -0000
Received: from unknown (HELO cmgw3) (10.0.90.84)
 by gproxy10.mail.unifiedlayer.com with SMTP; 3 Nov 2015 19:54:37 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw3 with 
 id dDuV1r0182UdiVW01DuYUJ; Tue, 03 Nov 2015 18:54:35 -0700
X-Authority-Analysis: v=2.1 cv=Zs1+dbLG c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=vaJtXVxTAAAA:8 a=cPh2J7tIEGPIyMH75qQA:9
Received: from [76.218.37.33] (port=64577 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Zthf5-0000P9-5J; Tue, 03 Nov 2015 12:54:31 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN>
Date: Tue, 03 Nov 2015 13:54:21 -0600
In-Reply-To: <5638DE4A.308@HIDDEN> (Dmitry Gutov's message of "Tue, 3 Nov
 2015 18:18:18 +0200")
Message-ID: <86h9l2270y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>,
 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Dmitry Gutov <dgutov@HIDDEN> writes:

> Why don't we canonicalize the file name somehow when an xref instance
> is created?

Yes; I have often thought Emacs needs a canonical file format. But first
we need a good definition for "canonical file name". The closest we have
now is "expand-file-name"; that does not fix case sensitivity.

I think a canonical name that includes case sensitivity would need a
rule like:

   If the file name identifies an existing file, convert the file name
   casing to match the actual file name casing. If not, no case
   conversion is done.

I'm not clear how to do the case conversion, but I bet Emacs does have
the right functions.

This does not handle comparing two file names for a not-yet-created file
that differ in case.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 3 Nov 2015 19:51:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 14:51:28 2015
Received: from localhost ([127.0.0.1]:51760 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zthc7-0003HH-UG
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:51:28 -0500
Received: from eggs.gnu.org ([208.118.235.92]:41889)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthc5-0003H8-P5
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:51:26 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthc1-0006mi-HG
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:51:25 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:48613)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthc1-0006mb-EI
 for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:51:21 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:51844)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthc0-0000qN-Ik
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:51:21 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthbw-0006jZ-Ha
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:51:20 -0500
Received: from plane.gmane.org ([80.91.229.3]:45040)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthbw-0006ic-BJ
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 14:51:16 -0500
Received: from list by plane.gmane.org with local (Exim 4.69)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1Zthbs-0007gN-1U
 for bug-gnu-emacs@HIDDEN; Tue, 03 Nov 2015 20:51:12 +0100
Received: from c-68-39-146-59.hsd1.in.comcast.net ([68.39.146.59])
 by main.gmane.org with esmtp (Gmexim 0.1 (Debian))
 id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 20:51:12 +0100
Received: from random832 by c-68-39-146-59.hsd1.in.comcast.net with local
 (Gmexim 0.1 (Debian)) id 1AlnuQ-0007hv-00
 for <bug-gnu-emacs@HIDDEN>; Tue, 03 Nov 2015 20:51:12 +0100
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Random832 <random832@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
Date: Tue, 03 Nov 2015 14:50:29 -0500
Lines: 6
Message-ID: <87lhaevp4q.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
X-Complaints-To: usenet@HIDDEN
X-Gmane-NNTP-Posting-Host: c-68-39-146-59.hsd1.in.comcast.net
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3 (gnu/linux)
Cancel-Lock: sha1:HIqFMvbyji14s4yhb/4ruGH/oqU=
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.1 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.1 (----)

Eli Zaretskii <eliz@HIDDEN> writes:
> Both forms (and some additional ones) are perfectly canonical.

That is a contradiction in terms. There can only be one canonical
form. If there is no viable way to privilege one form above all others,
then _no_ forms are canonical.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 19:44:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 14:44:45 2015
Received: from localhost ([127.0.0.1]:51756 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZthVc-00037D-Vd
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:44:45 -0500
Received: from gproxy5-pub.mail.unifiedlayer.com ([67.222.38.55]:47620)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZthVH-00036g-Vp
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:44:43 -0500
Received: (qmail 28463 invoked by uid 0); 3 Nov 2015 19:44:20 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy5.mail.unifiedlayer.com with SMTP; 3 Nov 2015 19:44:20 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id d7k61r00n2UdiVW017k95A; Tue, 03 Nov 2015 12:44:20 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=pGLkceISAAAA:8 a=MCf2BZoNQf-tHn1GXF4A:9
Received: from [76.218.37.33] (port=64515 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZthV0-0002UW-AP; Tue, 03 Nov 2015 12:44:06 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Juanma Barranquero <lekktu@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN>
 <CAAeL0SQJhbhwOPyQWPmEj8f5X=gAxrTRdQhtEAksLRAknHP8Fw@HIDDEN>
Date: Tue, 03 Nov 2015 13:43:56 -0600
In-Reply-To: <CAAeL0SQJhbhwOPyQWPmEj8f5X=gAxrTRdQhtEAksLRAknHP8Fw@HIDDEN>
 (Juanma Barranquero's message of "Tue, 3 Nov 2015 15:58:26 +0100")
Message-ID: <86lhae27ib.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Juanma Barranquero <lekktu@HIDDEN> writes:

> On Tue, Nov 3, 2015 at 3:51 PM, Stephen Leake <
> stephen_leake@HIDDEN> wrote:
>
>> What is the use case for these compares, other than tests?
>
> Avoiding duplicates? When adding an xref to a list of xrefs, how do you
> check that isn't it already there?

Currently we don't.

It may come up with some of the multi-backend projects I'm working on,
but in general the xref backends should cover disjoint sets of files, so
it should not happen.

It might happen with non-file xrefs; I haven't used those much.

You asked about "sorting xrefs"; the only sorting that is currently done
is in xref--analyze, which groups xrefs with the same filename. It uses
cl-assoc on the filename, which uses "equal" or "eq" for the string
comparison, I think. It does have a :test parameter we can use to
override that.

So that could fail due to filename case sensitivity; I'll see if I can
construct an example.

However, the fix for this is _not_ a "compare xref" function, since. A
canonicalized file name in the xref would be a fix, as would a "file
name case insensitive compare" function.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 19:25:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 14:25:11 2015
Received: from localhost ([127.0.0.1]:51752 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZthCh-0002dV-0g
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:25:11 -0500
Received: from gproxy7-pub.mail.unifiedlayer.com ([70.40.196.235]:60088)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZthCM-0002cn-O6
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 14:25:10 -0500
Received: (qmail 13103 invoked by uid 0); 3 Nov 2015 19:24:47 -0000
Received: from unknown (HELO CMOut01) (10.0.90.82)
 by gproxy7.mail.unifiedlayer.com with SMTP; 3 Nov 2015 19:24:47 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by CMOut01 with 
 id d7Qf1r01M2UdiVW017Qixf; Tue, 03 Nov 2015 12:24:46 -0700
X-Authority-Analysis: v=2.1 cv=VOBOwb/X c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=mDV3o1hIAAAA:8 a=du2QjpoP--1MU9LRikMA:9
Received: from [76.218.37.33] (port=64369 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZthCC-00086n-MG; Tue, 03 Nov 2015 12:24:40 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
Date: Tue, 03 Nov 2015 13:24:31 -0600
In-Reply-To: <83d1vrw0p9.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 03 Nov
 2015 17:40:34 +0200")
Message-ID: <86pozq28eo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> Sorry to bust this party, guys, but I don't think this solution is
> "good enough".  

In general, or just for this test?

Let's fix the test first, and worry about the general case later.

> First, it won't DTRT with Windows file names that have
> backslashes (yes, they happen in Emacs).  

That's easy; add `expand-file-name'.

> Second, 'downcase' has a known gotcha of using the current buffer's
> case tables, which is something you definitely don't want here.

Ah; I had not considered non-ASCII stuff.

Is there some global variable we can let-bind to control that?

> Bottom line, doing this "right" is not so trivial, and a dedicated
> function is a better solution, IMO.  If you put it in files-x.el, it
> could be reused by other Lisp programs in the need of this.

Yes, that makes sense.

> IME, it doesn't pay off to use such incomplete solutions, the result
> is an annoying, albeit minor, maintenance burden.  

Not in this test.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 18:19:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 13:19:11 2015
Received: from localhost ([127.0.0.1]:51745 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtgAp-00013q-LQ
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:19:11 -0500
Received: from mail-wm0-f49.google.com ([74.125.82.49]:33788)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1ZtgAV-000134-R1
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:19:10 -0500
Received: by wmeg8 with SMTP id g8so91746082wme.0
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 10:18:51 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=2RtuWtrmrIYOhkvEPhK/oqqkDy/86WcwfT9vdocLhHI=;
 b=AVDGYAoT6XPgQAqt+sZbyb3TU0BpxFWrtjCuJw/KX3+ZQjGO2C2G5BFhU5PdgdH4qa
 a0RRi8lUn+90Tknc/AKY4/ONWGtFrdpPq8f3VURt24WZ5AE1HXsapxp77rJzSXbBWVtm
 wlntBCUF+UdRcSKYjGexiG1VDCtbj8tGF2cA2DSl0AgK0LIxwGeJfGJuHMzV7UA/cVKA
 TU1+ZR9oBSqBwXD7G9SFAoeMPsnpWpA8LJjiHvrDyG8hrCFh1zfYePB5HfMRcouWrl/M
 inB8wr50aBbJ3e0FcL8hWvSlaxN3XGhL7SLqiZ8uR6YUCoJyJ1WRrnF/Hit68lndGcil
 uZaw==
X-Received: by 10.28.16.203 with SMTP id 194mr22832021wmq.55.1446574731220;
 Tue, 03 Nov 2015 10:18:51 -0800 (PST)
Received: from [192.168.1.2] ([185.105.175.24])
 by smtp.googlemail.com with ESMTPSA id q141sm24630010wmg.3.2015.11.03.10.18.49
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 10:18:50 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5638FA88.8050702@HIDDEN>
Date: Tue, 3 Nov 2015 20:18:48 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <83ziyvujmj.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/03/2015 06:34 PM, Eli Zaretskii wrote:

> Both forms (and some additional ones) are perfectly canonical.

Like suggested, let's pick one? Speaking of personal preferences, it 
would be the form with forward slashes, and with path segments written 
with capitalization that the file system prefers. I know NTFS does 
prefer *one* of many way to write each file name, even if it accepts others.

> This isn't a xref-specific problem, so I think it should have a more
> general solution that any package could use.  It's not reasonable to
> expect from every Emacs developer to be an expert on subtle aspects of
> comparing Windows file names.  We should provide a tested solution for
> that.

I don't know which solution to pick, and I believe I don't know the 
problem well enough. We probably don't want to venture into Java-land 
here, and encapsulate any type of field into its separate data type, 
with its comparison function. But, well, we could do that.

In any case, it's not a hugely important problem, compared to others we 
still have.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 18:14:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 13:14:02 2015
Received: from localhost ([127.0.0.1]:51741 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztg5p-0007mk-Uq
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:14:02 -0500
Received: from mail-wm0-f54.google.com ([74.125.82.54]:33854)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1Ztg5o-0007md-Po
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:14:01 -0500
Received: by wmff134 with SMTP id f134so91328635wmf.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 10:14:00 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=EzIrTuO5NNOBVjocp0F+WfjXAoiC3GyT66ROqo1qmOc=;
 b=D06sdjMNbd64PYo5Olj+Q6Vgb33+keN7M/rvGHsqeU/CVDDgee5u3x1b/gyuugIxGp
 eVk4kDrjQWXGHuDN5i6ndTdRughKcXcwY2WKqMKip4MTbA4mHvRxoJUpq3WYl3p0mYm4
 ZX66iwVvXGpfdVa6LG1LQHUrg//GvB36TzyKgBPD8c+mJ5hxg6OasDtDurnBgWwA10Iz
 fin7JO8DVam3K1iQ7f5ovXUC0TQRsrfPTxmOGn5qtGGD1fc2D+Dp1XxT5qre+CB1v3eZ
 10xUru6l8xbH1sIoe68DXlKwJZEZSsaT4zZQyI0sVW2JDAH41lXUy6YoM6INyyvnAJgO
 kXHg==
X-Received: by 10.28.173.194 with SMTP id w185mr21882272wme.23.1446574440236; 
 Tue, 03 Nov 2015 10:14:00 -0800 (PST)
Received: from [192.168.1.2] ([185.105.175.24])
 by smtp.googlemail.com with ESMTPSA id n17sm24581348wmg.17.2015.11.03.10.13.58
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 10:13:59 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>, Juanma Barranquero <lekktu@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
 <83y4efuiqq.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5638F966.4050700@HIDDEN>
Date: Tue, 3 Nov 2015 20:13:58 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <83y4efuiqq.fsf@HIDDEN>
Content-Type: text/plain; charset=windows-1252; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/03/2015 06:53 PM, Eli Zaretskii wrote:

> You mean, ref doesn't know that some strings are file names and some
> aren't?  Then how does it know they are strings and not symbols or
> something else?  This is Lisp, not C.

Lisp has a "string" data type. It doesn't have a "file" data type. It's 
not Java.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 18:12:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 13:12:49 2015
Received: from localhost ([127.0.0.1]:51737 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztg4f-0007kd-CP
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:12:49 -0500
Received: from mail-wm0-f43.google.com ([74.125.82.43]:36583)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1Ztg4d-0007kV-78
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 13:12:47 -0500
Received: by wmec75 with SMTP id c75so93713539wme.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 10:12:46 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=UCnEpn40LwCE9/+garw8yXAJsL9xzBGa1Cnz7eg5mbQ=;
 b=EDp6i0c45oJubuOcP/U48R2/mc9sbDob1q0Byp0Uiju8LAJwEhswDY19rV4sikudcJ
 hz8ILQsmJs6rBy9ILk2CO7371ahbJHflEZmBCJlqOu1majLzR/Q/atAyPvo5vcDcNzH3
 cU19jSRaZfXmA1DcdHdrelrwJvByjM8/36r0cmX0BeuaSGXsrUf2kuCpnFjsVgFvAyDu
 GWu7WdUkLwcmYCIFhPBG4cktRHEFCui0D6bSAyiaY7ebHRlu8XTvePCCjWC7GZQQl4tq
 bYa+3MMz06lgbi8LboQKJhcSxhSldT9WLHhobCpv8ibkr5ZZAJPRmD1p5iJcu4EComhX
 b08w==
X-Received: by 10.28.9.73 with SMTP id 70mr22446099wmj.42.1446574366634;
 Tue, 03 Nov 2015 10:12:46 -0800 (PST)
Received: from [192.168.1.2] ([185.105.175.24])
 by smtp.googlemail.com with ESMTPSA id ki7sm28802583wjc.28.2015.11.03.10.12.44
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 10:12:45 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Juanma Barranquero <lekktu@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN>
 <CAAeL0ST8DJfTG1EZ1i0TviwchLmxJmHMGb-gB06k5Hg_CRAdOw@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5638F91B.1060601@HIDDEN>
Date: Tue, 3 Nov 2015 20:12:43 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <CAAeL0ST8DJfTG1EZ1i0TviwchLmxJmHMGb-gB06k5Hg_CRAdOw@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/03/2015 06:33 PM, Juanma Barranquero wrote:

> I'm OK with that, but then we need to add a comment or something to xref
> explicitly stating that, when deriving new types from xref-location (or
> xref-item, if someone adds a file slot to it for whatever reason) all
> filenames *must* be kept canonicalized.

Yes, that would need to mentioned somewhere. And if someone were to 
point me to a "canonicalize file name" function (or suggest a quick 
implementation), I'd document that right away.

> And then, someone will derive from xref-location and add propertized
> strings and will want to compare *including* the properties...

Maybe they would, but you already understand that it's not a realistic 
example. Anything they might want to store in the properties, they can 
store inside their xref-derived instance.

> No, of course I cannot think of a use case right now, but again, it's
> infrastructure. It's there to help generalization and reuse.

When we add a new generic function, it's good to document exactly what 
is expected of its implementations. Which is hard to do without knowing 
use cases.

>  > It can be solved as above, for example.
>
> Until someone adds tests for etags and wants to compare two
> xref-etag-location instances (which include a file slot), and then they
> will have to copy the code from elisp-mode-tests.el.

Why *-tests.el? Canonicalization should happen inside the constructor 
function, if anywhere. E.g. inside xref-make-file-location and 
xref-make-elisp-location.

> `equal' already is quite broad, so I'd bet
> many subtypes will never require anything more complex than the default
> xref-compare-locations.

Which is my point exactly. Let's not complicate things until we have to.

> Now that I think of it... How do you sort xref-items and xref-locations?

We display the items in the order they were returned. Works pretty well.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:53:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:53:58 2015
Received: from localhost ([127.0.0.1]:51675 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZteqL-000474-Bc
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:53:57 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:45301)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Zteq0-00046W-Aj
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:53:55 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
 a-mtaout21.012.net.il (HyperSendmail v2007.08) id
 <0NX900K0007GE800@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Tue, 03 Nov 2015 18:53:34 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout21.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX900KIS09A9390@HIDDEN>;
 Tue, 03 Nov 2015 18:53:34 +0200 (IST)
Date: Tue, 03 Nov 2015 18:53:49 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Juanma Barranquero <lekktu@HIDDEN>
Message-id: <83y4efuiqq.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
 <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Juanma Barranquero <lekktu@HIDDEN>
> Date: Tue, 3 Nov 2015 17:42:28 +0100
> Cc: Dmitry Gutov <dgutov@HIDDEN>, 21816 <at> debbugs.gnu.org, 
> 	Stephen Leake <stephen_leake@HIDDEN>
> 
> > This isn't a xref-specific problem, so I think it should have a more
> > general solution that any package could use. It's not reasonable to
> > expect from every Emacs developer to be an expert on subtle aspects of
> > comparing Windows file names. We should provide a tested solution for
> > that.
> 
> That would be helpful in general, but wouldn't help with the case that now, to
> compare two xref-location instances, you have to delve into their innards.
> Different problems.
> 
> <rambling>Unless you're proposing a variant of `equal' with better
> file-comparing abilities... which doesn't make sense because `equal-super-duper
> ` wouldn't have a way to know that some things are filenames and not just
> arbitrary strings that match a filename just by happenstance...</rambling>

You mean, ref doesn't know that some strings are file names and some
aren't?  Then how does it know they are strings and not symbols or
something else?  This is Lisp, not C.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:43:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:43:11 2015
Received: from localhost ([127.0.0.1]:51671 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztefv-0003qz-3N
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:43:11 -0500
Received: from mail-lf0-f49.google.com ([209.85.215.49]:32793)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Zteft-0003qr-2v
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:43:09 -0500
Received: by lfbf136 with SMTP id f136so24737757lfb.0
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 08:43:08 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=HSEmPL1DsB3boaWZW21R9J+4uwn/fQR5HmSrzXr7ECk=;
 b=S6YR+kljIN0aCPNCnVyKQ4QLVPABYKBpBdRgnuVZx002+myklc9qngVwPj84cRaXkT
 lwTYDAR7L3OP5y8Xx0winAHc5rF3ukk65BMbjvT2VNFETIMst8YfGFZYHfMdNfpRK7bN
 vqQ4dSc1vuAY1aw+s7rh3SA55GSk0aMA6CyaHDMztD0drpyi8YpYiYpLwGmfonw2Tvc9
 6w7cYJHpzwtSMo7MOtdXGWbMV6z//kfq/X6Lfl1vf2RbffMLTJ1l9JiaNTJVb5r7HqzJ
 EABjBiDWGaMPgpB/VNj9BlSIbmpghg1JW5RyYR+7XhZDwKqoJx0Yr/gSI3X7yMhsH33k
 kKfg==
X-Received: by 10.112.61.226 with SMTP id t2mr13329043lbr.11.1446568988231;
 Tue, 03 Nov 2015 08:43:08 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 08:42:28 -0800 (PST)
In-Reply-To: <83ziyvujmj.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN> <83ziyvujmj.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 17:42:28 +0100
Message-ID: <CAAeL0SRJ+7MVorhcu693kr_tgqTkpgAjqo_X4T8oX3u0T_6wrQ@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c3eebcafcd9b0523a5962c
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3eebcafcd9b0523a5962c
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 5:34 PM, Eli Zaretskii <eliz@HIDDEN> wrote:

> Both forms (and some additional ones) are perfectly canonical.

It would be a matter of choosing one.

> This isn't a xref-specific problem, so I think it should have a more
> general solution that any package could use.  It's not reasonable to
> expect from every Emacs developer to be an expert on subtle aspects of
> comparing Windows file names.  We should provide a tested solution for
> that.

That would be helpful in general, but wouldn't help with the case that now,
to compare two xref-location instances, you have to delve into their
innards. Different problems.

<rambling>Unless you're proposing a variant of `equal' with better
file-comparing abilities... which doesn't make sense because
`equal-super-duper` wouldn't have a way to know that some things are
filenames and not just arbitrary strings that match a filename just by
happenstance...</rambling>

--001a11c3eebcafcd9b0523a5962c
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 5:34 PM, Eli Zaretskii &lt;<a href=
=3D"mailto:eliz@HIDDEN">eliz@HIDDEN</a>&gt; wrote:<br><br><div>&gt; Both =
forms (and some additional ones) are perfectly canonical.<br><br></div><div=
>It would be a matter of choosing one.</div><div><br></div><div>&gt; This i=
sn&#39;t a xref-specific problem, so I think it should have a more<br>&gt; =
general solution that any package could use.=C2=A0 It&#39;s not reasonable =
to<br>&gt; expect from every Emacs developer to be an expert on subtle aspe=
cts of<br>&gt; comparing Windows file names.=C2=A0 We should provide a test=
ed solution for<br>&gt; that.</div><div><br></div><div>That would be helpfu=
l in general, but wouldn&#39;t help with the case that now, to compare two =
xref-location instances, you have to delve into their innards. Different pr=
oblems.</div><div><br></div><div>&lt;rambling&gt;Unless you&#39;re proposin=
g a variant of `equal&#39; with better file-comparing abilities... which do=
esn&#39;t make sense because `equal-super-duper` wouldn&#39;t have a way to=
 know that some things are filenames and not just arbitrary strings that ma=
tch a filename just by happenstance...&lt;/rambling&gt;</div><div><br></div=
></div>

--001a11c3eebcafcd9b0523a5962c--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:35:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:35:14 2015
Received: from localhost ([127.0.0.1]:51661 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZteYE-0003eM-1j
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:35:14 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:36805)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZteYA-0003e2-WD
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:35:12 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
 a-mtaout22.012.net.il (HyperSendmail v2007.08) id
 <0NX800H00ZCD5H00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Tue, 03 Nov 2015 18:34:29 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout22.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX800GNLZDGN1B0@HIDDEN>;
 Tue, 03 Nov 2015 18:34:29 +0200 (IST)
Date: Tue, 03 Nov 2015 18:34:44 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <5638DE4A.308@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Dmitry Gutov <dgutov@HIDDEN>
Message-id: <83ziyvujmj.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
>  Stephen Leake <stephen_leake@HIDDEN>
> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Tue, 3 Nov 2015 18:18:18 +0200
> 
> On 11/03/2015 06:04 PM, Juanma Barranquero wrote:
> 
> > I'm not sure where you're arguing that
> >
> > a) xrefs never need to be compared
> > b) they are sometimes, but it's ok to use equal and fail in
> > case-preserving and case-insensitive systems
> 
> Why don't we canonicalize the file name somehow when an xref instance is 
> created?

Both forms (and some additional ones) are perfectly canonical.

> > I'm a bit surprised to be discussing that the basic type offered by an
> > infrastructure library as xref needs ways to be compared...
> 
> Compared in an impementation-specialized way? Yes, I'd like to see a use 
> case.
> 
> It's very nontrivial to write a comparison function that would work 
> beyond the type you're currently defining (just one xref subtype). 
> Hence, its applicability will probably be rather limited.

This isn't a xref-specific problem, so I think it should have a more
general solution that any package could use.  It's not reasonable to
expect from every Emacs developer to be an expert on subtle aspects of
comparing Windows file names.  We should provide a tested solution for
that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:34:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:34:13 2015
Received: from localhost ([127.0.0.1]:51656 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZteXF-0003bD-EM
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:34:13 -0500
Received: from mail-lf0-f53.google.com ([209.85.215.53]:34489)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZteWv-0003aA-ID
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:34:12 -0500
Received: by lfgh9 with SMTP id h9so24376420lfg.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 08:33:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=9yme8IaM702CJKDvGebAVZ4f0XRIuXJP0jNiCvZW5Kw=;
 b=viSeXWdWhKNfOyS4+8kOpoO3JsWfajbcdDPtSN8yn1gXOrogIv5TFN6ABrf9y5uzEZ
 P5+oix1V10qgxZlHFe972gNc1p828pzqyWGoOLAUBBUjNX2X8XZukeZUUn4v7XZ+fi6C
 A5Rkf5X2Q6VXh00k7txFOkX3a8JXXzJHRGiilFg//8dG6XrA4QA/hS/nX9Qvm8JelU8w
 JGtLm9KkAhtBy27dykPkrac4B03P7he+SQ7nEGHfOTuyKptwo0x/aONbHPhxzOMktRdZ
 bH94beemmMhDaMHa9SE6Ub7UBVQIOI9mUHhGXstVq04rpN4FP+pjdj1boX4dlulxtwEU
 Jqlg==
X-Received: by 10.112.62.194 with SMTP id a2mr13507901lbs.80.1446568432679;
 Tue, 03 Nov 2015 08:33:52 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 08:33:13 -0800 (PST)
In-Reply-To: <5638DE4A.308@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
 <5638DE4A.308@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 17:33:13 +0100
Message-ID: <CAAeL0ST8DJfTG1EZ1i0TviwchLmxJmHMGb-gB06k5Hg_CRAdOw@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Dmitry Gutov <dgutov@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c3c46e92c54d0523a575d1
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3c46e92c54d0523a575d1
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 5:18 PM, Dmitry Gutov <dgutov@HIDDEN> wrote:

> Why don't we canonicalize the file name somehow when an xref instance is
created?

I'm OK with that, but then we need to add a comment or something to xref
explicitly stating that, when deriving new types from xref-location (or
xref-item, if someone adds a file slot to it for whatever reason) all
filenames *must* be kept canonicalized.

And then, someone will derive from xref-location and add propertized
strings and will want to compare *including* the properties...

No, of course I cannot think of a use case right now, but again, it's
infrastructure. It's there to help generalization and reuse.

> It can be solved as above, for example.

Until someone adds tests for etags and wants to compare two
xref-etag-location instances (which include a file slot), and then they
will have to copy the code from elisp-mode-tests.el.

> It's very nontrivial to write a comparison function that would work
beyond the type
> you're currently defining (just one xref subtype). Hence, its
applicability will probably
> be rather limited.

Well, you define a generic function that defaults to using `equal', and let
subtypes do the refining. `equal' already is quite broad, so I'd bet many
subtypes will never require anything more complex than the default
xref-compare-locations.

Now that I think of it... How do you sort xref-items and xref-locations?

--001a11c3c46e92c54d0523a575d1
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 5:18 PM, Dmitry Gutov &lt;<a href=
=3D"mailto:dgutov@HIDDEN" target=3D"_blank">dgutov@HIDDEN</a>&gt; wro=
te:<br><br><div>&gt; Why don&#39;t we canonicalize the file name somehow wh=
en an xref instance is created?<br><br></div><div>I&#39;m OK with that, but=
 then we need to add a comment or something to xref explicitly stating that=
, when deriving new types from xref-location (or xref-item, if someone adds=
 a file slot to it for whatever reason) all filenames *must* be kept canoni=
calized.</div><div><br></div><div>And then, someone will derive from xref-l=
ocation and add propertized strings and will want to compare *including* th=
e properties...</div><div><br></div><div>No, of course I cannot think of a =
use case right now, but again, it&#39;s infrastructure. It&#39;s there to h=
elp generalization and reuse.</div><div><br></div><div>&gt; It can be solve=
d as above, for example.<br><br></div><div>Until someone adds tests for eta=
gs and wants to compare two xref-etag-location instances (which include a f=
ile slot), and then they will have to copy the code from elisp-mode-tests.e=
l.</div><div><br></div><div>&gt; It&#39;s very nontrivial to write a compar=
ison function that would work beyond the type</div><div>&gt; you&#39;re cur=
rently defining (just one xref subtype). Hence, its applicability will prob=
ably</div><div>&gt; be rather limited.</div><div><br></div><div>Well, you d=
efine a generic function that defaults to using `equal&#39;, and let subtyp=
es do the refining. `equal&#39; already is quite broad, so I&#39;d bet many=
 subtypes will never require anything more complex than the default xref-co=
mpare-locations.</div><div><br></div><div>Now that I think of it... How do =
you sort xref-items and xref-locations?</div></div>

--001a11c3c46e92c54d0523a575d1--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:18:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:18:23 2015
Received: from localhost ([127.0.0.1]:51648 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZteHv-0003As-9p
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:18:23 -0500
Received: from mail-wi0-f172.google.com ([209.85.212.172]:34250)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1ZteHt-0003Aj-Ss
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:18:22 -0500
Received: by wikq8 with SMTP id q8so75006426wik.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 08:18:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=B44Di5Rw/2cxqQZmHcGAO9LYYBqrmmWXoX04DW6Qu2Y=;
 b=cfldkjCdTVRy/GGJCT1MyLmUoO74SFiJNo5owDSVAmVjtJoS8sLZzjhqIfoKwRe4h6
 szBuQV7weKz9iJAQnBg46AjV0HcF/3xovaADe9kg9O0+eMf++NQC2r8z2a/sZ+b38mB9
 9ZdZV3lG+hEdZldvLJp+9T12pozT1vGljtUcSHcCG7owmDudlynObCbfR65BRReOjtKE
 vaT7+xkHtdfgJYpQ9FvOmqXtZr9VrzRBh9Grb2YjOKRgC2XxO5w2QO1VMvJGk67BPqCz
 phDSMVPmqIXdqV63CTtW3ieINodQ1slBb9qCeBl0bQSFjE6WzPYcZCpw4hfxAWQtS7Uz
 0JbA==
X-Received: by 10.194.243.232 with SMTP id xb8mr30079805wjc.138.1446567501216; 
 Tue, 03 Nov 2015 08:18:21 -0800 (PST)
Received: from [10.9.0.103] (nat.webazilla.com. [78.140.128.228])
 by smtp.googlemail.com with ESMTPSA id h4sm28289321wjx.41.2015.11.03.08.18.19
 (version=TLSv1.2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 03 Nov 2015 08:18:20 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Juanma Barranquero <lekktu@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
 <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5638DE4A.308@HIDDEN>
Date: Tue, 3 Nov 2015 18:18:18 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 11/03/2015 06:04 PM, Juanma Barranquero wrote:

> I'm not sure where you're arguing that
>
> a) xrefs never need to be compared
> b) they are sometimes, but it's ok to use equal and fail in
> case-preserving and case-insensitive systems

Why don't we canonicalize the file name somehow when an xref instance is 
created?

> We're here discussing a real one: a test that needs an ad hoc fix
> because it couldn't just compare two xrefs. Or do you think that writing
> tests isn't a real-life example?

It can be solved as above, for example.

> I'm a bit surprised to be discussing that the basic type offered by an
> infrastructure library as xref needs ways to be compared...

Compared in an impementation-specialized way? Yes, I'd like to see a use 
case.

It's very nontrivial to write a comparison function that would work 
beyond the type you're currently defining (just one xref subtype). 
Hence, its applicability will probably be rather limited.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 16:05:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 11:05:15 2015
Received: from localhost ([127.0.0.1]:51642 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Zte5C-0002q3-S3
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:05:15 -0500
Received: from mail-lf0-f53.google.com ([209.85.215.53]:34586)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Zte4s-0002ox-LP
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 11:05:13 -0500
Received: by lfgh9 with SMTP id h9so23296721lfg.1
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 08:04:53 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=jSomr/U8YqY+tRhQAESvaXC19ldn1Ai7BxctTvpgBXg=;
 b=lsyy+2eQRfSgcWfGidKRSFOHVNeLeuBB253MIKoj1OmKqc2AUDskEGVeU4M/A2eYB3
 oqbvn8QFaMt81nXK+sQZfdjmm85onI2IxWjRMU1PJszUR5Bd0WIuHQLBNsh+hDqUTEGP
 9yqzQ0UICYTLPYNwi5P1qhDchBwcMBnseEMqjN01N/wjFr9JCH4pdYoYlmKPjldgt3L0
 9cC8MHVVkDmNegVLceMrFWwtptKt+WcSGD6MBXq5yl8KXRxsVnhFX/N3Q47Kf2p8ayYS
 bgnLw5AOqh9le0Rt+nK4t8LtQgPDIJ4DpJg8cin3t6d2rFwQ/hXst7rZB7i/zDP37Fb9
 MKOA==
X-Received: by 10.25.80.80 with SMTP id e77mr8687304lfb.11.1446566693868; Tue,
 03 Nov 2015 08:04:53 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 08:04:14 -0800 (PST)
In-Reply-To: <5638D836.8090600@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
 <5638D836.8090600@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 17:04:14 +0100
Message-ID: <CAAeL0SSRQ17FVD98r3pGd_j1iregsmsz5bgBoVnQ1-2VGqEYKA@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Dmitry Gutov <dgutov@HIDDEN>
Content-Type: multipart/alternative; boundary=001a1141d86eee9a520523a50da8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: Eli Zaretskii <eliz@HIDDEN>, 21816 <at> debbugs.gnu.org,
 Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a1141d86eee9a520523a50da8
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 4:52 PM, Dmitry Gutov <dgutov@HIDDEN> wrote:

> Just to make it work better, in theory, on case-sensitive filesystems?

I'm not sure where you're arguing that

a) xrefs never need to be compared
b) they are sometimes, but it's ok to use equal and fail in case-preserving
and case-insensitive systems

> Please produce a real-life example of breakage first, please.

We're here discussing a real one: a test that needs an ad hoc fix because
it couldn't just compare two xrefs. Or do you think that writing tests
isn't a real-life example?

I'm a bit surprised to be discussing that the basic type offered by an
infrastructure library as xref needs ways to be compared...

--001a1141d86eee9a520523a50da8
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 4:52 PM, Dmitry Gutov &lt;<a href=
=3D"mailto:dgutov@HIDDEN">dgutov@HIDDEN</a>&gt; wrote:<br><br><div>&g=
t; Just to make it work better, in theory, on case-sensitive filesystems?<b=
r><br></div><div>I&#39;m not sure where you&#39;re arguing that</div><div><=
br></div><div>a) xrefs never need to be compared</div><div>b) they are some=
times, but it&#39;s ok to use equal and fail in case-preserving and case-in=
sensitive systems</div><div><br></div><div>&gt; Please produce a real-life =
example of breakage first, please.<br></div><div><br></div><div>We&#39;re h=
ere discussing a real one: a test that needs an ad hoc fix because it could=
n&#39;t just compare two xrefs. Or do you think that writing tests isn&#39;=
t a real-life example?</div><div><br></div><div>I&#39;m a bit surprised to =
be discussing that the basic type offered by an infrastructure library as x=
ref needs ways to be compared...</div><div><br></div></div>

--001a1141d86eee9a520523a50da8--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 15:52:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 10:52:46 2015
Received: from localhost ([127.0.0.1]:51634 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztdt8-0002WO-3j
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:52:46 -0500
Received: from mail-wm0-f50.google.com ([74.125.82.50]:35566)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <raaahh@HIDDEN>) id 1Ztdsn-0002Vv-Rq
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:52:44 -0500
Received: by wmll128 with SMTP id l128so90875081wml.0
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 07:52:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:subject:to:references:cc:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-type:content-transfer-encoding;
 bh=MV06V/qfZDZnECE+crQbDzvOIWiYBK/trtktNnokBmM=;
 b=l5yfcMdDh35lMdfOZwqG0s6N5DCSlwmapvGqevKnRZtliK7qtjfie6S024Va3tbtqs
 1u2yBSx7YAqyxxgu4Xoo3slpihlz0hZPAEToCFwIGoFr5J/00Q9xqmDCTAcRLj87HMyk
 A4SQu7cCmPdmTgxV8A7+8Scshjl4F+4GmxJLH46/fpMDUxt9Qmvw1njAupVMT75ObePt
 uK2DIOFnrIaaLaXpUcz1TEzht4tbrc/6dDsUFiLgqTh65boRJo4x7H7ZnluVddBLsF3Y
 Tm4Kh2GJwoCP0UHOQ4ywQIz3MGKOrYGfvAouyCnuCShFiWSSEWpyeZvk4+y+c3bL3et3
 xxUQ==
X-Received: by 10.28.54.197 with SMTP id y66mr18917322wmh.31.1446565944933;
 Tue, 03 Nov 2015 07:52:24 -0800 (PST)
Received: from [192.168.0.185] (static-nbl2-118.cytanet.com.cy.
 [212.31.107.118])
 by smtp.googlemail.com with ESMTPSA id kd8sm12145126wjc.27.2015.11.03.07.52.23
 (version=TLSv1/SSLv3 cipher=OTHER);
 Tue, 03 Nov 2015 07:52:24 -0800 (PST)
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Juanma Barranquero <lekktu@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
 <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5638D836.8090600@HIDDEN>
Date: Tue, 3 Nov 2015 17:52:22 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:42.0) Gecko/20100101
 Thunderbird/42.0
MIME-Version: 1.0
In-Reply-To: <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 11/03/2015 05:45 PM, Juanma Barranquero wrote:

> But, as I've said, I think the real fix is adding generic comparison
> functions to xrefs.

Just to make it work better, in theory, on case-sensitive filesystems?

Please produce a real-life example of breakage first, please.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 15:46:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 10:46:17 2015
Received: from localhost ([127.0.0.1]:51626 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztdmq-0002MM-Pf
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:46:17 -0500
Received: from mail-lf0-f47.google.com ([209.85.215.47]:36500)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Ztdmp-0002ME-50
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:46:15 -0500
Received: by lffz202 with SMTP id z202so22931491lff.3
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 07:46:14 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=rcx09KcB5o+BI0eNeFd/tK50lB6cwr9eD966G17q5Dc=;
 b=Mudgeb1DmFJg9sSBLuOx85Or3dYPhyvt6+MSRHS+GKLh8mxI7QCW/wsplXdQPbNrGn
 +A74Y3DkZpkYC9+YL+cWU+Nr3iCFo+vAO8wXrmdJi8DnEMRxr4MWiFJ67EnaojEicbVG
 KSgGp5adDRVBNSq0KbfuX6gHKRgAkfDka3ciNLMJDSdq9qnow63RV9ysQBB7h62IJNeN
 G4RH+nhHGlTdYRUCPY2VyBoEgIMy5xGJ4XW+U/dLmFOZAFEcJWD3T+S1TP4h5E63O9uD
 aTKNIimpRD5FVp462+O+1OpN98OhlJjr0mTGG/SsU5B+A5zSjviSGfO90GKfA+RsfOFR
 iH1Q==
X-Received: by 10.112.77.10 with SMTP id o10mr13493284lbw.28.1446565574073;
 Tue, 03 Nov 2015 07:46:14 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 07:45:31 -0800 (PST)
In-Reply-To: <83d1vrw0p9.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN> <83d1vrw0p9.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 16:45:31 +0100
Message-ID: <CAAeL0SSONOhN73=KbPF-fwC--69u0-aGr-DEtEPs6dcbCaQpmg@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c3ba822fe9ea0523a4cbf8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c3ba822fe9ea0523a4cbf8
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 4:40 PM, Eli Zaretskii <eliz@HIDDEN> wrote:

> Sorry to bust this party, guys, but I don't think this solution is
> "good enough".  First, it won't DTRT with Windows file names that have
> backslashes (yes, they happen in Emacs).  Second, 'downcase' has a
> known gotcha of using the current buffer's case tables, which is
> something you definitely don't want here.

I take Stephen's commit as a fix for the current tests. The tests are not
about comparison.

But, as I've said, I think the real fix is adding generic comparison
functions to xrefs.

--001a11c3ba822fe9ea0523a4cbf8
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 4:40 PM, Eli Zaretskii &lt;<a href=
=3D"mailto:eliz@HIDDEN">eliz@HIDDEN</a>&gt; wrote:<br><br><div>&gt; Sorry=
 to bust this party, guys, but I don&#39;t think this solution is<br>&gt; &=
quot;good enough&quot;.=C2=A0 First, it won&#39;t DTRT with Windows file na=
mes that have<br>&gt; backslashes (yes, they happen in Emacs).=C2=A0 Second=
, &#39;downcase&#39; has a<br>&gt; known gotcha of using the current buffer=
&#39;s case tables, which is<br>&gt; something you definitely don&#39;t wan=
t here.<br><br></div><div>I take Stephen&#39;s commit as a fix for the curr=
ent tests. The tests are not about comparison.</div><div><br></div><div>But=
, as I&#39;ve said, I think the real fix is adding generic comparison funct=
ions to xrefs.</div><div><br></div></div>

--001a11c3ba822fe9ea0523a4cbf8--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 15:40:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 10:40:40 2015
Received: from localhost ([127.0.0.1]:51620 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtdhP-0002Cq-Ba
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:40:39 -0500
Received: from mtaout29.012.net.il ([80.179.55.185]:33739)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtdhL-0002Cf-7C
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 10:40:37 -0500
Received: from conversion-daemon.mtaout29.012.net.il by mtaout29.012.net.il
 (HyperSendmail v2007.08) id <0NX800N00WNS5K00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 17:39:40 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout29.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX800KXUWU4CM30@HIDDEN>; Tue, 03 Nov 2015 17:39:40 +0200 (IST)
Date: Tue, 03 Nov 2015 17:40:34 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <86y4ef16ha.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Leake <stephen_leake@HIDDEN>
Message-id: <83d1vrw0p9.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: lekktu@HIDDEN, 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Stephen Leake <stephen_leake@HIDDEN>
> Date: Tue, 03 Nov 2015 08:51:29 -0600
> Cc: 21816 <at> debbugs.gnu.org
> 
> >> The canonical solution for case-insensitive string comparisons is to use
> >> `downcase' on both values before using `equal'. This works for me:
> >
> > It works for me too, though I get a whole bunch of warnings running the
> > test:
> >
> > c:/devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el and
> > c:/Devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el are the same
> > file
> 
> Which is why I always put the right case in `load-path' :).

You cannot rely on that, in general.  File names don't have to come
from load-path, and load-path is not entirely under your control.

> There's probably a way (other than fixing your load-path) to suppress
> those warnings; ert can redirect errors in general. I did not look into
> it.
> 
> More worrisome is this from the byte compiler:
> 
> In xref-elisp-test-run:
> ../../../master/test/automated/elisp-mode-tests.el:185:57:Warning: Unknown
>     slot `:location'
> ../../../master/test/automated/elisp-mode-tests.el:189:60:Warning: Unknown
>     slot `:location'
> 
> yet the code runs and the tests pass. Changing ":location" to "location"
> fixes the warning.
> 
> There are also several "unused lexical arg" warnings; see the WORKAROUND
> comment.
> 
> >> If no one objects to this, I'll commit it.
> >
> > Please do, thanks.
> 
> Done.

Sorry to bust this party, guys, but I don't think this solution is
"good enough".  First, it won't DTRT with Windows file names that have
backslashes (yes, they happen in Emacs).  Second, 'downcase' has a
known gotcha of using the current buffer's case tables, which is
something you definitely don't want here.

Bottom line, doing this "right" is not so trivial, and a dedicated
function is a better solution, IMO.  If you put it in files-x.el, it
could be reused by other Lisp programs in the need of this.

IME, it doesn't pay off to use such incomplete solutions, the result
is an annoying, albeit minor, maintenance burden.  It's much better
IMO to fix this once and for all, then we could just forget about this
issue.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 14:59:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 09:59:27 2015
Received: from localhost ([127.0.0.1]:51600 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ztd3X-00019k-Eo
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 09:59:27 -0500
Received: from mail-lf0-f43.google.com ([209.85.215.43]:35997)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1Ztd3D-00019D-Cz
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 09:59:26 -0500
Received: by lffz202 with SMTP id z202so21114615lff.3
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 06:59:06 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=CHWYNJlfuRy9iDRn06NMx1AEl6DRsazzqNEY4BRF2r8=;
 b=FyW9H/Ro7UKb8GRIa8+LNRPI0M5WbZgr9lYjz2b8pN44zmypZDsEODsX96pcABSnkp
 JSoLptU4KZwlO5+BhZLdQ3wBHENek9Ds2qnhgDvqfQkWxg/aSMGlNg5up0bCJOKJS2xo
 bUjwst8Fg9lNGDnYHVG9rq8Usx1LRyacxW2jtPxqZTWujnwknSTRG1qcCHI80NlPqSM7
 f9aKF8fO8j+0BxpJ2d358ZaUnhmp8uSRCH4VWVDAokZxEj3iMmNykAyNglVgdpYsXYQI
 SBJ4Rm1WsH9fSPE2XqXqUCe9WH+YrdDLsOQ+G2j8mP1QgNHA37KKJbyTJcxpIWPFBH9g
 1Ymw==
X-Received: by 10.112.72.201 with SMTP id f9mr13562264lbv.62.1446562746213;
 Tue, 03 Nov 2015 06:59:06 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 06:58:26 -0800 (PST)
In-Reply-To: <86y4ef16ha.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 <86y4ef16ha.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 15:58:26 +0100
Message-ID: <CAAeL0SQJhbhwOPyQWPmEj8f5X=gAxrTRdQhtEAksLRAknHP8Fw@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c24000a22be00523a42232
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c24000a22be00523a42232
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 3:51 PM, Stephen Leake <
stephen_leake@HIDDEN> wrote:

> What is the use case for these compares, other than tests?

Avoiding duplicates? When adding an xref to a list of xrefs, how do you
check that isn't it already there?

> Which is why I always put the right case in `load-path' :).

I haven't set my load-path. Its value comes straight of  autoconf /
configure / make bootstrap.

> There are also several "unused lexical arg" warnings; see the WORKAROUND
> comment.

Yes, I saw them. But these are warnings when byte-compiling the test file.
The "same file" warnings happen when running the tests.

I'll look into silencing them.

> Done.

Thanks.

--001a11c24000a22be00523a42232
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 3:51 PM, Stephen Leake &lt;<a href=
=3D"mailto:stephen_leake@HIDDEN">stephen_leake@HIDDEN</=
a>&gt; wrote:<br><br><div>&gt; What is the use case for these compares, oth=
er than tests?<br><br></div><div>Avoiding duplicates? When adding an xref t=
o a list of xrefs, how do you check that isn&#39;t it already there?</div><=
div><br></div><div>&gt; Which is why I always put the right case in `load-p=
ath&#39; :).<br><br></div><div>I haven&#39;t set my load-path. Its value co=
mes straight of =C2=A0autoconf / configure / make bootstrap.</div><div><br>=
</div><div>&gt; There are also several &quot;unused lexical arg&quot; warni=
ngs; see the WORKAROUND<br></div><div>&gt; comment.<br><br></div><div>Yes, =
I saw them. But these are warnings when byte-compiling the test file. The &=
quot;same file&quot; warnings happen when running the tests.</div><div><br>=
</div><div>I&#39;ll look into silencing them.</div><div><br></div><div>&gt;=
 Done.<br><br></div><div>Thanks.</div></div>

--001a11c24000a22be00523a42232--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 14:51:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 09:51:54 2015
Received: from localhost ([127.0.0.1]:50604 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtcwE-0000kN-EE
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 09:51:54 -0500
Received: from gproxy7-pub.mail.unifiedlayer.com ([70.40.196.235]:40795)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZtcwC-0000kE-4w
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 09:51:53 -0500
Received: (qmail 9396 invoked by uid 0); 3 Nov 2015 14:51:50 -0000
Received: from unknown (HELO cmgw4) (10.0.90.85)
 by gproxy7.mail.unifiedlayer.com with SMTP; 3 Nov 2015 14:51:50 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by cmgw4 with 
 id d2rl1r00s2UdiVW012roQQ; Tue, 03 Nov 2015 07:51:50 -0700
X-Authority-Analysis: v=2.1 cv=IekUBwaa c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=pGLkceISAAAA:8 a=T1pit3izLiN3II8zns8A:9
Received: from [76.218.37.33] (port=62714 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1Ztcw5-0002Bk-GO; Tue, 03 Nov 2015 07:51:45 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Juanma Barranquero <lekktu@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
 <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
Date: Tue, 03 Nov 2015 08:51:29 -0600
In-Reply-To: <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
 (Juanma Barranquero's message of "Tue, 3 Nov 2015 11:06:57 +0100")
Message-ID: <86y4ef16ha.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Juanma Barranquero <lekktu@HIDDEN> writes:

> On Tue, Nov 3, 2015 at 10:17 AM, Stephen Leake <
> stephen_leake@HIDDEN> wrote:
>
>> Well, since this is only a problem in a test run by developers (not
>> general users), we _could_ insist on that, but I agree it would be nice
>> not to.
>
> I think it points to a problem with xrefs in general. IMO xref-location
> should have a generic compare function (specialized by default on
> xref-file-location) so two of them can be compared other than by `equal'
> and get the right result in case-insensitive systems. And xref-item should
> also have a generic compare function, whose default implementation would
> use xref-compare-locations (or whatever the name) to compare its location
> slots.

What is the use case for these compares, other than tests?

>> The canonical solution for case-insensitive string comparisons is to use
>> `downcase' on both values before using `equal'. This works for me:
>
> It works for me too, though I get a whole bunch of warnings running the
> test:
>
> c:/devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el and
> c:/Devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el are the same
> file

Which is why I always put the right case in `load-path' :).

There's probably a way (other than fixing your load-path) to suppress
those warnings; ert can redirect errors in general. I did not look into
it.

More worrisome is this from the byte compiler:

In xref-elisp-test-run:
../../../master/test/automated/elisp-mode-tests.el:185:57:Warning: Unknown
    slot `:location'
../../../master/test/automated/elisp-mode-tests.el:189:60:Warning: Unknown
    slot `:location'

yet the code runs and the tests pass. Changing ":location" to "location"
fixes the warning.

There are also several "unused lexical arg" warnings; see the WORKAROUND
comment.

>> If no one objects to this, I'll commit it.
>
> Please do, thanks.

Done.

--
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 10:07:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 05:07:41 2015
Received: from localhost ([127.0.0.1]:50445 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtYVA-0007qa-Mu
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 05:07:41 -0500
Received: from mail-lf0-f44.google.com ([209.85.215.44]:35969)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZtYV8-0007qR-HS
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 05:07:39 -0500
Received: by lffz202 with SMTP id z202so11801856lff.3
 for <21816 <at> debbugs.gnu.org>; Tue, 03 Nov 2015 02:07:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=X7D7tP4kBXgB47Y+epRtbzwtm7tkmciDRjaD57RZvc8=;
 b=PN1hP4OYxJnj8zopRrqUgVui2LrC+sgUd0fO66MpkZivm4D3atRtBJP8f/s7X4pnz6
 kofWu53//9EbjDAzJheBjrS5SwVXJU8sEVIatYQoae/kBEt1RiG+pvCUjVM8xItAFXEz
 Xn7yDX+4Puh3Ro3/j5JDqfkUq/9fR5r3C13CExlGhYF1nLjdNVTX+oqvIWqyJdO50GBW
 DCTZyXGsZchreUinjXjXP0cJ2L+sahoCvuMVcKVcl3q0BZHFMcMiXeC6FfO+uy17t6Cv
 hycnWdHa7R+Axx2RLxIFvRnfYifiYrVErthtSs0sNBwzCA67aZqcpaOmFfIM3ucwhw2X
 38JA==
X-Received: by 10.25.20.24 with SMTP id k24mr8299747lfi.117.1446545257506;
 Tue, 03 Nov 2015 02:07:37 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Tue, 3 Nov 2015 02:06:57 -0800 (PST)
In-Reply-To: <86mvuv30i1.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <86mvuv30i1.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 11:06:57 +0100
Message-ID: <CAAeL0SSTkW4W58+wkvZX0fKg8Dzuzi8K_+ccqz5UbK-0KijZeQ@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Stephen Leake <stephen_leake@HIDDEN>
Content-Type: multipart/alternative; boundary=001a113fbfd639ad5c0523a010fa
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a113fbfd639ad5c0523a010fa
Content-Type: text/plain; charset=UTF-8

On Tue, Nov 3, 2015 at 10:17 AM, Stephen Leake <
stephen_leake@HIDDEN> wrote:

> Well, since this is only a problem in a test run by developers (not
> general users), we _could_ insist on that, but I agree it would be nice
> not to.

I think it points to a problem with xrefs in general. IMO xref-location
should have a generic compare function (specialized by default on
xref-file-location) so two of them can be compared other than by `equal'
and get the right result in case-insensitive systems. And xref-item should
also have a generic compare function, whose default implementation would
use xref-compare-locations (or whatever the name) to compare its location
slots.

> The canonical solution for case-insensitive string comparisons is to use
> `downcase' on both values before using `equal'. This works for me:

It works for me too, though I get a whole bunch of warnings running the
test:

c:/devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el and
c:/Devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el are the same
file

> ;; We add 'downcase' here to deliberately cause a potential problem on
> ;; case-insensitive file systems. On such systems, `load-file-name'
> ;; may not have the same case as the real file system, since the user
> ;; can set `load-path' to have the wrong case. This is handled in
> ;; `xref-elisp-test-run'.

In case-insensitive (or, as Windows, case-preserving) systems, that's not
the "wrong" case, just an alternative ;-)

> If no one objects to this, I'll commit it.

Please do, thanks.

--001a113fbfd639ad5c0523a010fa
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Tue, Nov 3, 2015 at 10:17 AM, Stephen Leake &lt;<a href=
=3D"mailto:stephen_leake@HIDDEN">stephen_leake@HIDDEN</=
a>&gt; wrote:<br><br><div>&gt; Well, since this is only a problem in a test=
 run by developers (not<br></div><div>&gt; general users), we _could_ insis=
t on that, but I agree it would be nice<br>&gt; not to.<br><br></div><div>I=
 think it points to a problem with xrefs in general. IMO xref-location shou=
ld have a generic compare function (specialized by default on xref-file-loc=
ation) so two of them can be compared other than by `equal&#39; and get the=
 right result in case-insensitive systems. And xref-item should also have a=
 generic compare function, whose default implementation would use xref-comp=
are-locations (or whatever the name) to compare its location slots.</div><d=
iv><br></div><div>&gt; The canonical solution for case-insensitive string c=
omparisons is to use<br></div><div>&gt; `downcase&#39; on both values befor=
e using `equal&#39;. This works for me:<br><br></div><div>It works for me t=
oo, though I get a whole bunch of warnings running the test:</div><div><br>=
</div><div>c:/devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el and=
 c:/Devel/emacs/repo/trunk/test/automated/elisp-mode-tests.el are the same =
file<br></div><div><br></div><div>&gt; ;; We add &#39;downcase&#39; here to=
 deliberately cause a potential problem on<br></div><div>&gt; ;; case-insen=
sitive file systems. On such systems, `load-file-name&#39;<br>&gt; ;; may n=
ot have the same case as the real file system, since the user<br>&gt; ;; ca=
n set `load-path&#39; to have the wrong case. This is handled in<br>&gt; ;;=
 `xref-elisp-test-run&#39;.<br><br></div><div>In case-insensitive (or, as W=
indows, case-preserving) systems, that&#39;s not the &quot;wrong&quot; case=
, just an alternative ;-)</div><div><br></div><div>&gt; If no one objects t=
o this, I&#39;ll commit it.<br><br></div><div>Please do, thanks.</div></div=
>

--001a113fbfd639ad5c0523a010fa--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 09:18:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 03 04:18:12 2015
Received: from localhost ([127.0.0.1]:50417 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtXjI-0006Dp-0C
	for submit <at> debbugs.gnu.org; Tue, 03 Nov 2015 04:18:12 -0500
Received: from gproxy5-pub.mail.unifiedlayer.com ([67.222.38.55]:34520)
 by debbugs.gnu.org with smtp (Exim 4.80)
 (envelope-from <stephen_leake@HIDDEN>) id 1ZtXjB-0006DX-W2
 for 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 04:18:10 -0500
Received: (qmail 19527 invoked by uid 0); 3 Nov 2015 09:18:01 -0000
Received: from unknown (HELO CMOut01) (10.0.90.82)
 by gproxy5.mail.unifiedlayer.com with SMTP; 3 Nov 2015 09:18:01 -0000
Received: from host114.hostmonster.com ([74.220.207.114]) by CMOut01 with 
 id cxHv1r00e2UdiVW01xHyJm; Tue, 03 Nov 2015 02:18:00 -0700
X-Authority-Analysis: v=2.1 cv=VOBOwb/X c=1 sm=1 tr=0
 a=CQdxDb2CKd3SRg4I0/XZPQ==:117 a=CQdxDb2CKd3SRg4I0/XZPQ==:17 a=DsvgjBjRAAAA:8
 a=f5113yIGAAAA:8 a=9i_RQKNPAAAA:8 a=hEr_IkYJT6EA:10 a=x_XPkuGwIRMA:10
 a=qtqOOiqGOCEA:10 a=pGLkceISAAAA:8 a=E2KaSVAcxw75DkIxD9sA:9
 a=nD_X6M0ivBNE474w:21 a=7PeleKvK824uZp5h:21
Received: from [76.218.37.33] (port=60279 helo=TAKVER2)
 by host114.hostmonster.com with esmtpa (Exim 4.84)
 (envelope-from <stephen_leake@HIDDEN>)
 id 1ZtXj2-0006zl-C3; Tue, 03 Nov 2015 02:17:56 -0700
From: Stephen Leake <stephen_leake@HIDDEN>
To: Juanma Barranquero <lekktu@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-Reply-To: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 (Juanma Barranquero's message of "Mon, 2 Nov 2015 17:41:58 +0100")
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.5 (windows-nt)
Date: Tue, 03 Nov 2015 03:17:42 -0600
Message-ID: <86mvuv30i1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Identified-User: {2442:host114.hostmonster.com:stephele:stephe-leake.org}
 {sentby:smtp auth 76.218.37.33 authed with stephen_leake@HIDDEN}
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Juanma Barranquero <lekktu@HIDDEN> writes:

> Package: emacs
> Version: 25.0.50
> Severity: minor
> X-Debbugs-CC: stephen_leake@HIDDEN
>
>
> Test xref-elisp-test-find-defs-feature-el fails on my Windows system
> because of a case-sensitive filename comparison.
>
> Basically
>
> ELISP> (aref (aref (car (elisp--xref-find-definitions 'xref)) 2) 3)
> "c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"
>
> ELISP> (aref (xref-make-elisp-location
>      'xref 'feature
>      (expand-file-name "../../lisp/progmodes/xref.el"
> emacs-test-dir))
>     3)
> "c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"
>
> and the test fails at the d/D in c:/Devel vs. c:/devel (as seen in the log
> below).
>
> The value returned by `expand-file-name' is the real name as stored in the
> filesystem (the directory is called "Devel"). 

This is not caused by expand-file-name, but by the values passed to it.
In this case, `emacs-test-dir' has the "c:/Devel"; it is set by:

(defconst emacs-test-dir (file-name-directory (or load-file-name (buffer-file-name))))

I can reproduce the problem by adding a "downcase" to this; my emacs
test dir is in c:/Projects/..., but my load-path has the correct case.

> The value from
> `elisp--xref-find-definitions' ultimately comes from `locate-file', and
> reflects what's stored in `load-path' (which can be set by the user, so we
> cannot force it to have "correct" casing).

Well, since this is only a problem in a test run by developers (not
general users), we _could_ insist on that, but I agree it would be nice
not to.

> The test code in elisp-mode-tests.el uses `equal' to compare the xref
> structures. I can think a couple of ways to fix the test, but they are all
> quite ugly....

The canonical solution for case-insensitive string comparisons is to use
`downcase' on both values before using `equal'. This works for me:

(defun xref-elisp-test-run (xrefs expected-xrefs)
  (should (= (length xrefs) (length expected-xrefs)))
  (while xrefs
    (let* ((xref (pop xrefs))
           (expected (pop expected-xrefs))
           (expected-xref (or (when (consp expected) (car expected)) expected))
           (expected-source (when (consp expected) (cdr expected))))

      ;; Downcase the filename for case-insensitive file systems.
      (setf (xref-elisp-location-file (oref xref :location))
            (downcase (xref-elisp-location-file (oref xref :location))))

      (setf (xref-elisp-location-file (oref expected-xref :location))
            (downcase (xref-elisp-location-file (oref expected-xref :location))))

      (should (equal xref expected-xref))

      (xref--goto-location (xref-item-location xref))
      (back-to-indentation)
      (should (looking-at (or expected-source
                              (xref-elisp-test-descr-to-target expected)))))
    ))

together with:

;; We add 'downcase' here to deliberately cause a potential problem on
;; case-insensitive file systems. On such systems, `load-file-name'
;; may not have the same case as the real file system, since the user
;; can set `load-path' to have the wrong case. This is handled in
;; `xref-elisp-test-run'.
(defconst emacs-test-dir (downcase (file-name-directory (or load-file-name (buffer-file-name)))))


If no one objects to this, I'll commit it.

-- 
-- Stephe




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 03:42:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 02 22:42:18 2015
Received: from localhost ([127.0.0.1]:50242 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtSUD-0005mB-Rb
	for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 22:42:18 -0500
Received: from mtaout27.012.net.il ([80.179.55.183]:43345)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtSUC-0005m2-8t
 for 21816 <at> debbugs.gnu.org; Mon, 02 Nov 2015 22:42:17 -0500
Received: from conversion-daemon.mtaout27.012.net.il by mtaout27.012.net.il
 (HyperSendmail v2007.08) id <0NX700M00YYH9P00@HIDDEN> for
 21816 <at> debbugs.gnu.org; Tue, 03 Nov 2015 05:37:37 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by mtaout27.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX700MA9ZEPGD10@HIDDEN>; Tue, 03 Nov 2015 05:37:37 +0200 (IST)
Date: Tue, 03 Nov 2015 05:42:28 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <CAAeL0STds_Ay_LcWgPi2TyFRFOBHvf-Oe-9U1bdvvZuGe1pAnA@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Juanma Barranquero <lekktu@HIDDEN>
Message-id: <83k2pzwxy3.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <83vb9kwahe.fsf@HIDDEN>
 <CAAeL0SRhVuj+zx8AKournns6A3zisabp93o-vfjF1VBsi740yg@HIDDEN>
 <CAAeL0STds_Ay_LcWgPi2TyFRFOBHvf-Oe-9U1bdvvZuGe1pAnA@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Juanma Barranquero <lekktu@HIDDEN>
> Date: Tue, 3 Nov 2015 02:19:54 +0100
> Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>
> 
> An additional complication is that file-equal-p is intended to compare existing
> files ("If FILE1 or FILE2 does not exist, the return value is unspecified."),
> but the xref-elisp-location values do not seem to be so constrained.

We could introduce a new function, file-name-equal-p, say, that would
be free of this limitation (for the price of not being able to compare
a file name with its 8+3 short variant and such likes).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 3 Nov 2015 01:20:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 02 20:20:44 2015
Received: from localhost ([127.0.0.1]:50175 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtQHD-0002UJ-R9
	for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 20:20:44 -0500
Received: from mail-lf0-f54.google.com ([209.85.215.54]:35906)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZtQH4-0002U4-Sf
 for 21816 <at> debbugs.gnu.org; Mon, 02 Nov 2015 20:20:36 -0500
Received: by lffz202 with SMTP id z202so1669454lff.3
 for <21816 <at> debbugs.gnu.org>; Mon, 02 Nov 2015 17:20:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=Jw6aXbEOg/cIWVehw2aBx80WwR17YNIze9DsL/Wdn2E=;
 b=oswE1EIRxNF5qXgWP7vgo1aJ4qbYIPQWSrtK8vMsDxV6N0hCCviBVPF14WD11sfn11
 /VRR7d5Up6gpwncprzrzqTsOfgBwCgaUrzqAl7hYyd1CZkde/3dLNFUwyKtut/I8nZaT
 O9Sxdgit3v+o7E8m/xfgA2+ZWje72iEQbJoj4d55pNpj8gytASCPvWK40DsbphTDkDL9
 CXatNpKF9y6f59JO6ny0YN6XpVlomlBcdZepo6sul73UdTx+ZbEOhvA5UZwEoQ/oWq2r
 eDtRraWqNFA50b/KsWE5ZWQGzENgSA3Y0Dd1LRZDSJW/EWJHEEX+/MtiAn0AuQyhSB74
 vQ8Q==
X-Received: by 10.112.190.99 with SMTP id gp3mr3725593lbc.117.1446513633949;
 Mon, 02 Nov 2015 17:20:33 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Mon, 2 Nov 2015 17:19:54 -0800 (PST)
In-Reply-To: <CAAeL0SRhVuj+zx8AKournns6A3zisabp93o-vfjF1VBsi740yg@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <83vb9kwahe.fsf@HIDDEN>
 <CAAeL0SRhVuj+zx8AKournns6A3zisabp93o-vfjF1VBsi740yg@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Tue, 3 Nov 2015 02:19:54 +0100
Message-ID: <CAAeL0STds_Ay_LcWgPi2TyFRFOBHvf-Oe-9U1bdvvZuGe1pAnA@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c37ec8507e04052398b372
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c37ec8507e04052398b372
Content-Type: text/plain; charset=UTF-8

On Mon, Nov 2, 2015 at 7:20 PM, Juanma Barranquero <lekktu@HIDDEN> wrote:

> to defining a new comparing function, specific to this test. Which I
suppose I'll eventually do.

An additional complication is that file-equal-p is intended to compare
existing files ("If FILE1 or FILE2 does not exist, the return value is
unspecified."), but the xref-elisp-location values do not seem to be so
constrained. In elisp-mode-tests.el there are examples like

   (xref-make "(defun xref-find-definitions)"
     (xref-make-elisp-location
      'xref-find-definitions nil
      (expand-file-name "../../lisp/progmodes/xref.el" emacs-test-dir)))))

but also

   (xref-make "(defun buffer-live-p)"
     (xref-make-elisp-location 'buffer-live-p nil "src/buffer.c"))))

--001a11c37ec8507e04052398b372
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Mon, Nov 2, 2015 at 7:20 PM, Juanma Barranquero &lt;<a =
href=3D"mailto:lekktu@HIDDEN">lekktu@HIDDEN</a>&gt; wrote:<br><br><di=
v>&gt; to defining a new comparing function, specific to this test. Which I=
 suppose I&#39;ll eventually do.<br><br></div><div>An additional complicati=
on is that file-equal-p is intended to compare existing files (&quot;If FIL=
E1 or FILE2 does not exist, the return value is unspecified.&quot;), but th=
e xref-elisp-location values do not seem to be so constrained. In elisp-mod=
e-tests.el there are examples like</div><div><br></div><div><div>=C2=A0 =C2=
=A0(xref-make &quot;(defun xref-find-definitions)&quot;</div><div><span cla=
ss=3D"" style=3D"white-space:pre">	</span> =C2=A0 =C2=A0 =C2=A0(xref-make-e=
lisp-location</div><div><span class=3D"" style=3D"white-space:pre">	</span>=
 =C2=A0 =C2=A0 =C2=A0 &#39;xref-find-definitions nil</div><div><span class=
=3D"" style=3D"white-space:pre">	</span> =C2=A0 =C2=A0 =C2=A0 (expand-file-=
name &quot;../../lisp/progmodes/xref.el&quot; emacs-test-dir)))))</div></di=
v><div><br></div><div>but also</div><div><br></div><div><div>=C2=A0 =C2=A0(=
xref-make &quot;(defun buffer-live-p)&quot;</div><div><span class=3D"" styl=
e=3D"white-space:pre">	</span> =C2=A0 =C2=A0 =C2=A0(xref-make-elisp-locatio=
n &#39;buffer-live-p nil &quot;src/buffer.c&quot;))))</div></div><div><br><=
/div><div><br></div></div>

--001a11c37ec8507e04052398b372--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 2 Nov 2015 18:21:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 02 13:21:14 2015
Received: from localhost ([127.0.0.1]:49949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtJjG-0003z0-8Q
	for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 13:21:14 -0500
Received: from mail-lf0-f49.google.com ([209.85.215.49]:36485)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZtJjE-0003ys-HC
 for 21816 <at> debbugs.gnu.org; Mon, 02 Nov 2015 13:21:13 -0500
Received: by lffz202 with SMTP id z202so65723634lff.3
 for <21816 <at> debbugs.gnu.org>; Mon, 02 Nov 2015 10:21:11 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:from:date:message-id:subject:to
 :cc:content-type;
 bh=ZGOdoxinoZV+gAAfW0zy2reTtTKM/E9onItDp9SAbis=;
 b=zAo75UnExdlj6/JYnv27w2FakyKkFbdpi92i4TDaOIhgBRgqfGnLLx+Mm1huJuOabi
 6ciW8URuiIrKwpeCJ1EhKjab9G4PfGN08CxWVPC+pcqYQD6RcPHv/hHqp9S+TWGcbe0u
 7UVxm5w87MMA2mVpD1to8iYbvXBrJM76w0N6aPG8QeZ1CYyCOHslDIyBGLp9G7Ndakiv
 GiHogYOdjvK0Yk4ccv+d4JhITxv4borosHtpLs+hIECvoARugMZZQDJFW6jsaO26Ievq
 gQ7sOct7LoylHcOZ/eqAcQTjqPfYPAi6vfoMkf692iwfna/YpCKlwHN1UPkBhHhpYCZe
 2SzA==
X-Received: by 10.25.80.80 with SMTP id e77mr7023960lfb.11.1446488471471; Mon,
 02 Nov 2015 10:21:11 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Mon, 2 Nov 2015 10:20:31 -0800 (PST)
In-Reply-To: <83vb9kwahe.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
 <83vb9kwahe.fsf@HIDDEN>
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Mon, 2 Nov 2015 19:20:31 +0100
Message-ID: <CAAeL0SRhVuj+zx8AKournns6A3zisabp93o-vfjF1VBsi740yg@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/alternative; boundary=001a1141d86e838f3a052392d7c6
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, Stephen Leake <stephen_leake@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a1141d86e838f3a052392d7c6
Content-Type: text/plain; charset=UTF-8

On Mon, Nov 2, 2015 at 6:57 PM, Eli Zaretskii <eliz@HIDDEN> wrote:

> The comparison should use file-equal-p.

Yes, that's one of the ugly ways to fix it that I mentioned. "Ugly" because
the test, through a macro, is not comparing file names, but two structures,
which happen to have a field that contains a filename. IOW, we'll have to
go from

     (should (equal xref
                     (or (when (consp expected) (car expected)) expected)))

to defining a new comparing function, specific to this test. Which I
suppose I'll eventually do.

--001a1141d86e838f3a052392d7c6
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">On Mon, Nov 2, 2015 at 6:57 PM, Eli Zaretskii &lt;<a href=
=3D"mailto:eliz@HIDDEN">eliz@HIDDEN</a>&gt; wrote:<br><br><div>&gt; The c=
omparison should use file-equal-p.</div><div><br></div><div>Yes, that&#39;s=
 one of the ugly ways to fix it that I mentioned. &quot;Ugly&quot; because =
the test, through a macro, is not comparing file names, but two structures,=
 which happen to have a field that contains a filename. IOW, we&#39;ll have=
 to go from</div><div><br></div><div><div>=C2=A0 =C2=A0 =C2=A0(should (equa=
l xref</div><div>=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =
=C2=A0 =C2=A0 =C2=A0(or (when (consp expected) (car expected)) expected)))<=
/div></div><div><br></div><div>to defining a new comparing function, specif=
ic to this test. Which I suppose I&#39;ll eventually do.</div><div><br></di=
v></div>

--001a1141d86e838f3a052392d7c6--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at 21816 <at> debbugs.gnu.org:


Received: (at 21816) by debbugs.gnu.org; 2 Nov 2015 17:57:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 02 12:57:23 2015
Received: from localhost ([127.0.0.1]:49935 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtJMA-0003Mk-Sa
	for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 12:57:23 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:54767)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1ZtJLq-0003MK-Pn
 for 21816 <at> debbugs.gnu.org; Mon, 02 Nov 2015 12:57:22 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
 a-mtaout23.012.net.il (HyperSendmail v2007.08) id
 <0NX700B008BEAE00@HIDDEN> for 21816 <at> debbugs.gnu.org;
 Mon, 02 Nov 2015 19:56:49 +0200 (IST)
Received: from HOME-C4E4A596F7 ([84.94.185.246]) by a-mtaout23.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NX700B168IO45A0@HIDDEN>;
 Mon, 02 Nov 2015 19:56:49 +0200 (IST)
Date: Mon, 02 Nov 2015 19:57:01 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#21816: elisp-mode-tests fails on a case-preserving filesystem
In-reply-to: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Juanma Barranquero <lekktu@HIDDEN>
Message-id: <83vb9kwahe.fsf@HIDDEN>
References: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 21816
Cc: 21816 <at> debbugs.gnu.org, stephen_leake@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Juanma Barranquero <lekktu@HIDDEN>
> Date: Mon, 2 Nov 2015 17:41:58 +0100
> Cc: stephen_leake@HIDDEN
> 
> Test xref-elisp-test-find-defs-feature-el fails on my Windows system because of
> a case-sensitive filename comparison.
> 
> Basically
> 
> ELISP> (aref (aref (car (elisp--xref-find-definitions 'xref)) 2) 3)
> "c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"
> 
> ELISP> (aref (xref-make-elisp-location
> 'xref 'feature
> (expand-file-name "../../lisp/progmodes/xref.el"
> emacs-test-dir))
> 3)
> "c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"
> 
> and the test fails at the d/D in c:/Devel vs. c:/devel (as seen in the log
> below).
> 
> The value returned by `expand-file-name' is the real name as stored in the
> filesystem (the directory is called "Devel"). The value from
> `elisp--xref-find-definitions' ultimately comes from `locate-file', and
> reflects what's stored in `load-path' (which can be set by the user, so we
> cannot force it to have "correct" casing).
> 
> ELISP> (locate-file "xref" load-path '(".el"))
> "c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"
> ELISP> (locate-file "xref" '("c:/Devel/emacs/repo/trunk/lisp/progmodes") '
> (".el"))
> "c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"
> 
> The test code in elisp-mode-tests.el uses `equal' to compare the xref
> structures. I can think a couple of ways to fix the test, but they are all
> quite ugly....

The comparison should use file-equal-p.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Nov 2015 16:43:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 02 11:43:06 2015
Received: from localhost ([127.0.0.1]:49908 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZtICH-0001V6-9O
	for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 11:43:05 -0500
Received: from eggs.gnu.org ([208.118.235.92]:41961)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBw-0001UN-Qr
 for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 11:43:03 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBu-00071E-W5
 for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 11:42:44 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 HTML_MESSAGE,T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:36208)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBu-00071A-TH
 for submit <at> debbugs.gnu.org; Mon, 02 Nov 2015 11:42:42 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:51960)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBt-0000Om-Bo
 for bug-gnu-emacs@HIDDEN; Mon, 02 Nov 2015 11:42:42 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBr-000705-PE
 for bug-gnu-emacs@HIDDEN; Mon, 02 Nov 2015 11:42:41 -0500
Received: from mail-lb0-x232.google.com ([2a00:1450:4010:c04::232]:33263)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <lekktu@HIDDEN>) id 1ZtIBr-0006zz-DK
 for bug-gnu-emacs@HIDDEN; Mon, 02 Nov 2015 11:42:39 -0500
Received: by lbbec13 with SMTP id ec13so92979023lbb.0
 for <bug-gnu-emacs@HIDDEN>; Mon, 02 Nov 2015 08:42:38 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:from:date:message-id:subject:to:content-type;
 bh=EfIaT6ZZlJ2+2YlpmghTjsnidPyf9XqcRBR3yHT6K+8=;
 b=P+vqv2Ey6Fv+IG8lyfBdvfHScgfPHWMaTHzzHwRlVPB6KpT+pt4ct9zc52HufmLW9F
 Y9+KUpsv/21jBkSPgFeFJQ1oenAgUibejXmOV1XxWbgIXK7G2/lVgfzHzYG8BZflJzJX
 aZLNa+qrzQ/W/C5cXcVatJhLi50YR88btQXX9GHAKY1ku1tL3Atw5TTOlJRo5seCjxn0
 ZmY6cT2wvTBKxvsHc2Z+oiARcuwgmUwoiZ9EFLA5Pkuau+EROrttuUgsAEKBsB1nY4R0
 K5J3sEDvceUj8nTx4GrUKOxMelMxXNOX0NW6awaC8i6JJFNN9OLKs9uWB1fFZ7jJX7jm
 63+w==
X-Received: by 10.112.72.201 with SMTP id f9mr10891768lbv.62.1446482557864;
 Mon, 02 Nov 2015 08:42:37 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.217.132 with HTTP; Mon, 2 Nov 2015 08:41:58 -0800 (PST)
From: Juanma Barranquero <lekktu@HIDDEN>
Date: Mon, 2 Nov 2015 17:41:58 +0100
Message-ID: <CAAeL0SQLncO69=TuhRwWjh0OX5+HJnpcxwOccQLOu-hdO4uX+A@HIDDEN>
Subject: elisp-mode-tests fails on a case-preserving filesystem
To: Bug-Gnu-Emacs <bug-gnu-emacs@HIDDEN>
Content-Type: multipart/alternative; boundary=001a11c24000092a9c05239177c0
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

--001a11c24000092a9c05239177c0
Content-Type: text/plain; charset=UTF-8

Package: emacs
Version: 25.0.50
Severity: minor
X-Debbugs-CC: stephen_leake@HIDDEN


Test xref-elisp-test-find-defs-feature-el fails on my Windows system
because of a case-sensitive filename comparison.

Basically

ELISP> (aref (aref (car (elisp--xref-find-definitions 'xref)) 2) 3)
"c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"

ELISP> (aref (xref-make-elisp-location
     'xref 'feature
     (expand-file-name "../../lisp/progmodes/xref.el"
emacs-test-dir))
    3)
"c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"

and the test fails at the d/D in c:/Devel vs. c:/devel (as seen in the log
below).

The value returned by `expand-file-name' is the real name as stored in the
filesystem (the directory is called "Devel"). The value from
`elisp--xref-find-definitions' ultimately comes from `locate-file', and
reflects what's stored in `load-path' (which can be set by the user, so we
cannot force it to have "correct" casing).

ELISP> (locate-file "xref" load-path '(".el"))
"c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"
ELISP> (locate-file "xref" '("c:/Devel/emacs/repo/trunk/lisp/progmodes")
'(".el"))
"c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"

The test code in elisp-mode-tests.el uses `equal' to compare the xref
structures. I can think a couple of ways to fix the test, but they are all
quite ugly....




Test xref-elisp-test-find-defs-feature-el backtrace:
  (if (unwind-protect (setq value-107 (apply fn-105 args-106)) (setq f
  (let (form-description-109) (if (unwind-protect (setq value-107 (app
  (let ((value-107 (quote ert-form-evaluation-aborted-108))) (let (for
  (let ((fn-105 (function equal)) (args-106 (list xref (or (if (consp
  (let ((xref (car-safe (prog1 xrefs (setq xrefs (cdr xrefs))))) (expe
  (while xrefs (let ((xref (car-safe (prog1 xrefs (setq xrefs (cdr xre
  xref-elisp-test-run(([eieio-class-tag--xref-item #("(feature xref)"
  (closure (cl-struct-xref-elisp-root-type-tags t) nil (xref-elisp-tes
  ert--run-test-internal([cl-struct-ert--test-execution-info [cl-struc
  ert-run-test([cl-struct-ert-test xref-elisp-test-find-defs-feature-e
  ert-run-or-rerun-test([cl-struct-ert--stats t [[cl-struct-ert-test e
  ert-run-tests(t #[385 "\306 \307\"\203G \211\211G\310U\203 \211@\20
  ert-run-tests-batch(nil)
  ert-run-tests-batch-and-exit()
  command-line-1(("-l" "ert" "-l" "elisp-mode-tests.el" "-f" "ert-run-
  command-line()
  normal-top-level()
Test xref-elisp-test-find-defs-feature-el condition:
    (ert-test-failed
     ((should
       (equal xref
              (or ... expected)))
      :form
      (equal
       [eieio-class-tag--xref-item
        #("(feature xref)" 1 8 ... 9 13 ...)
        [cl-struct-xref-elisp-location xref feature
"c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el"]]
       [eieio-class-tag--xref-item "(feature xref)"
                                   [cl-struct-xref-elisp-location xref
feature "c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el"]])
      :value nil :explanation
      (array-elt 2
                 (array-elt 3
                            (array-elt 3 ...)))))
   FAILED  34/35  xref-elisp-test-find-defs-feature-el
   passed  35/35  xref-elisp-test-find-defs-feature-eval

Ran 35 tests, 34 results as expected, 1 unexpected (2015-11-02
17:11:45+0100)

1 unexpected results:
   FAILED  xref-elisp-test-find-defs-feature-el

--001a11c24000092a9c05239177c0
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Package: emacs<div>Version: 25.0.50</div><div>Severity: mi=
nor</div><div>X-Debbugs-CC:=C2=A0<span style=3D"color:rgb(85,85,85);font-si=
ze:12.8px"><a href=3D"mailto:stephen_leake@HIDDEN">stephen_leake@=
stephe-leake.org</a></span></div><div><span style=3D"color:rgb(85,85,85);fo=
nt-size:12.8px"><br></span></div><div><span style=3D"color:rgb(85,85,85);fo=
nt-size:12.8px"><br></span></div><div><span style=3D"color:rgb(85,85,85);fo=
nt-size:12.8px">Test xref-elisp-test-find-defs-feature-el fails on my Windo=
ws system because of a case-sensitive filename comparison.</span></div><div=
><span style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div><div=
><span style=3D"color:rgb(85,85,85);font-size:12.8px">Basically</span></div=
><div><span style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div=
><div><div style=3D""><div><div><font color=3D"#555555"><span style=3D"font=
-size:12.8px">ELISP&gt; (aref (aref (car (elisp--xref-find-definitions &#39=
;xref)) 2) 3)</span></font></div><div><font color=3D"#555555"><span style=
=3D"font-size:12.8px">&quot;c:/devel/emacs/repo/trunk/lisp/progmodes/xref.e=
l&quot;</span></font></div><div><font color=3D"#555555"><span style=3D"font=
-size:12.8px"><br></span></font></div><div><font color=3D"#555555"><span st=
yle=3D"font-size:12.8px">ELISP&gt; (aref (xref-make-elisp-location</span></=
font></div><div><font color=3D"#555555"><span style=3D"font-size:12.8px"><s=
pan class=3D"" style=3D"white-space:pre">	</span> =C2=A0 =C2=A0 =C2=A0&#39;=
xref &#39;feature</span></font></div><div><font color=3D"#555555"><span sty=
le=3D"font-size:12.8px"><span class=3D"" style=3D"white-space:pre">	</span>=
 =C2=A0 =C2=A0 =C2=A0(expand-file-name &quot;../../lisp/progmodes/xref.el&q=
uot;</span></font></div><div><font color=3D"#555555"><span style=3D"font-si=
ze:12.8px"><span class=3D"" style=3D"white-space:pre">				</span>emacs-test=
-dir))</span></font></div><div><font color=3D"#555555"><span style=3D"font-=
size:12.8px"><span class=3D"" style=3D"white-space:pre">	</span> =C2=A0 =C2=
=A0 3)</span></font></div><div><font color=3D"#555555"><span style=3D"font-=
size:12.8px">&quot;c:/Devel/emacs/repo/trunk/lisp/progmodes/xref.el&quot;</=
span></font></div></div><div><br></div><div><span style=3D"color:rgb(85,85,=
85);font-size:12.8px">and the test fails at the d/D in c:/Devel vs. c:/deve=
l (as seen in the log below).</span><br></div><div><span style=3D"color:rgb=
(85,85,85);font-size:12.8px"><br></span></div><div><font color=3D"#555555">=
<span style=3D"font-size:12.8px">The value returned by `expand-file-name&#3=
9; is the real name as stored in the filesystem (the directory is called &q=
uot;Devel&quot;). The value from `elisp--xref-find-definitions&#39; ultimat=
ely comes from `locate-file&#39;, and reflects what&#39;s stored in `load-p=
ath&#39; (which can be set by the user, so we cannot force it to have &quot=
;correct&quot; casing).</span></font></div><div><br></div><div><font color=
=3D"#555555"><div style=3D""><span style=3D"font-size:12.8px">ELISP&gt; (lo=
cate-file &quot;xref&quot; load-path &#39;(&quot;.el&quot;))</span></div><d=
iv style=3D""><span style=3D"font-size:12.8px">&quot;c:/devel/emacs/repo/tr=
unk/lisp/progmodes/xref.el&quot;</span></div><div style=3D""><span style=3D=
"font-size:12.8px">ELISP&gt; (locate-file &quot;xref&quot; &#39;(&quot;c:/D=
evel/emacs/repo/trunk/lisp/progmodes&quot;) &#39;(&quot;.el&quot;))</span><=
/div><div style=3D""><span style=3D"font-size:12.8px">&quot;c:/Devel/emacs/=
repo/trunk/lisp/progmodes/xref.el&quot;</span></div><div style=3D"font-size=
:12.8px"><br></div></font></div></div></div><div><font color=3D"#555555"><s=
pan style=3D"font-size:12.8px">The test code in elisp-mode-tests.el uses `e=
qual&#39; to compare the xref structures. I can think a couple of ways to f=
ix the test, but they are all quite ugly....</span></font></div><div><span =
style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div><div><span =
style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div><div><span =
style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div><div><span =
style=3D"color:rgb(85,85,85);font-size:12.8px"><br></span></div><div><div s=
tyle=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">Test xre=
f-elisp-test-find-defs-feature-el backtrace:</span></font></div><div style=
=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 (if (=
unwind-protect (setq value-107 (apply fn-105 args-106)) (setq f</span></fon=
t></div><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12=
.8px">=C2=A0 (let (form-description-109) (if (unwind-protect (setq value-10=
7 (app</span></font></div><div style=3D""><font color=3D"#555555"><span sty=
le=3D"font-size:12.8px">=C2=A0 (let ((value-107 (quote ert-form-evaluation-=
aborted-108))) (let (for</span></font></div><div style=3D""><font color=3D"=
#555555"><span style=3D"font-size:12.8px">=C2=A0 (let ((fn-105 (function eq=
ual)) (args-106 (list xref (or (if (consp</span></font></div><div style=3D"=
"><font color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 (let ((xr=
ef (car-safe (prog1 xrefs (setq xrefs (cdr xrefs))))) (expe</span></font></=
div><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px=
">=C2=A0 (while xrefs (let ((xref (car-safe (prog1 xrefs (setq xrefs (cdr x=
re</span></font></div><div style=3D""><font color=3D"#555555"><span style=
=3D"font-size:12.8px">=C2=A0 xref-elisp-test-run(([eieio-class-tag--xref-it=
em #(&quot;(feature xref)&quot;</span></font></div><div style=3D""><font co=
lor=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 (closure (cl-struct=
-xref-elisp-root-type-tags t) nil (xref-elisp-tes</span></font></div><div s=
tyle=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 e=
rt--run-test-internal([cl-struct-ert--test-execution-info [cl-struc</span><=
/font></div><div style=3D""><font color=3D"#555555"><span style=3D"font-siz=
e:12.8px">=C2=A0 ert-run-test([cl-struct-ert-test xref-elisp-test-find-defs=
-feature-e</span></font></div><div style=3D""><font color=3D"#555555"><span=
 style=3D"font-size:12.8px">=C2=A0 ert-run-or-rerun-test([cl-struct-ert--st=
ats t [[cl-struct-ert-test e</span></font></div><div style=3D""><font color=
=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 ert-run-tests(t #[385 =
&quot;\306 \307\&quot;\203G \211\211G\310U\203  \211@\20</span></font></div=
><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=
=C2=A0 ert-run-tests-batch(nil)</span></font></div><div style=3D""><font co=
lor=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 ert-run-tests-batch=
-and-exit()</span></font></div><div style=3D""><font color=3D"#555555"><spa=
n style=3D"font-size:12.8px">=C2=A0 command-line-1((&quot;-l&quot; &quot;er=
t&quot; &quot;-l&quot; &quot;elisp-mode-tests.el&quot; &quot;-f&quot; &quot=
;ert-run-</span></font></div><div style=3D""><font color=3D"#555555"><span =
style=3D"font-size:12.8px">=C2=A0 command-line()</span></font></div><div st=
yle=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 no=
rmal-top-level()</span></font></div><div style=3D""><font color=3D"#555555"=
><span style=3D"font-size:12.8px">Test xref-elisp-test-find-defs-feature-el=
 condition:</span></font></div><div style=3D""><font color=3D"#555555"><spa=
n style=3D"font-size:12.8px">=C2=A0 =C2=A0 (ert-test-failed</span></font></=
div><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px=
">=C2=A0 =C2=A0 =C2=A0((should</span></font></div><div style=3D""><font col=
or=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =C2=A0=
(equal xref</span></font></div><div style=3D""><font color=3D"#555555"><spa=
n style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=
=A0 (or ... expected)))</span></font></div><div style=3D""><font color=3D"#=
555555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 :form</span><=
/font></div><div style=3D""><font color=3D"#555555"><span style=3D"font-siz=
e:12.8px">=C2=A0 =C2=A0 =C2=A0 (equal</span></font></div><div style=3D""><f=
ont color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0=
 =C2=A0[eieio-class-tag--xref-item</span></font></div><div style=3D""><font=
 color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =
=C2=A0 #(&quot;(feature xref)&quot; 1 8 ... 9 13 ...)</span></font></div><d=
iv style=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=C2=
=A0 =C2=A0 =C2=A0 =C2=A0 [cl-struct-xref-elisp-location xref feature &quot;=
c:/devel/emacs/repo/trunk/lisp/progmodes/xref.el&quot;]]</span></font></div=
><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12.8px">=
=C2=A0 =C2=A0 =C2=A0 =C2=A0[eieio-class-tag--xref-item &quot;(feature xref)=
&quot;</span></font></div><div style=3D""><font color=3D"#555555"><span sty=
le=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=
=A0[cl-struct-xref-elisp-location xref feature &quot;c:/Devel/emacs/repo/tr=
unk/lisp/progmodes/xref.el&quot;]])</span></font></div><div style=3D""><fon=
t color=3D"#555555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 :=
value nil :explanation</span></font></div><div style=3D""><font color=3D"#5=
55555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 (array-elt 2</=
span></font></div><div style=3D""><font color=3D"#555555"><span style=3D"fo=
nt-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=
=A0(array-elt 3</span></font></div><div style=3D""><font color=3D"#555555">=
<span style=3D"font-size:12.8px">=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (array-elt 3 ...)))=
))</span></font></div><div style=3D""><font color=3D"#555555"><span style=
=3D"font-size:12.8px">=C2=A0 =C2=A0FAILED =C2=A034/35 =C2=A0xref-elisp-test=
-find-defs-feature-el</span></font></div><div style=3D""><font color=3D"#55=
5555"><span style=3D"font-size:12.8px">=C2=A0 =C2=A0passed =C2=A035/35 =C2=
=A0xref-elisp-test-find-defs-feature-eval</span></font></div><div style=3D"=
"><font color=3D"#555555"><span style=3D"font-size:12.8px"><br></span></fon=
t></div><div style=3D""><font color=3D"#555555"><span style=3D"font-size:12=
.8px">Ran 35 tests, 34 results as expected, 1 unexpected (2015-11-02 17:11:=
45+0100)</span></font></div><div style=3D""><font color=3D"#555555"><span s=
tyle=3D"font-size:12.8px"><br></span></font></div><div style=3D""><font col=
or=3D"#555555"><span style=3D"font-size:12.8px">1 unexpected results:</span=
></font></div><div style=3D""><font color=3D"#555555"><span style=3D"font-s=
ize:12.8px">=C2=A0 =C2=A0FAILED =C2=A0xref-elisp-test-find-defs-feature-el<=
/span></font></div></div><div style=3D""><font color=3D"#555555"><span styl=
e=3D"font-size:12.8px"><br></span></font></div></div>

--001a11c24000092a9c05239177c0--




Acknowledgement sent to Juanma Barranquero <lekktu@HIDDEN>:
New bug report received and forwarded. Copy sent to stephen_leake@HIDDEN, bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to stephen_leake@HIDDEN, bug-gnu-emacs@HIDDEN:
bug#21816; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 5 Nov 2015 12:30:05 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.